<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3GUISelect extends wm3GUIField
  {
   // Arrays

   // Variables

   function __construct($name,$value = '',$label = '', $data = array())
    {
     // $data must be an array of wm3GUIOption objects
	 parent::__construct($name,$value,$label,$data);
    }

   public function render()
    {
     // Create a select from wm3GUIOption objects array with a default value $this->value
     if(count($this->_DATA) == 0) return '';
     if($this->id) $id = "id=\"$this->id\""; else $id = '';
     $str = "<select $id $this->javascript name=\"$this->name\">";
     foreach($this->_DATA as $option)
      {
       if($option->value == $this->value) $option->setSelected(true);
       else                               $option->setSelected(false);
       $str .= $option->render();
      }
     $str .= "</select>";
     return $this->extra_content_before.$str.$this->extra_content_after;
    }

  }

?>
