<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3GUITextField extends wm3GUIField
  {
   // Arrays

   // Variables
   private $side,$maxlenght,$type_password;

   function __construct($name,$value = '',$label = '', $size = 60, $maxlength = 255, $type_password = false)
    {
	 parent::__construct($name,$value,$label);
	 $this->size          = $size;
	 $this->maxlength     = $maxlength;
	 $this->type_password = $type_password;
    }

   public function render()
    {
	 // Render text field
     $this->value = wm3Util::quoteHTML($this->value);
     if($this->type_password) { $type = 'password'; $this->value = ''; } else $type = 'text';
     if($this->inactive) $inactive = "disabled"; else $inactive = '';
     if(!$this->id) $str = "<input type=\"$type\" name=\"$this->name\" value=\"$this->value\" size=\"$this->size\" maxlength=\"$this->maxlength\" $this->javascript $inactive>";
     else           $str = "<input id=\"$this->id\" type=\"$type\" name=\"$this->name\" value=\"$this->value\" size=\"$this->size\" maxlength=\"$this->maxlength\" $this->javascript $inactive>";
     return $this->extra_content_before.$str.$this->extra_content_after;     
	}

  }

?>
