<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Logs
  {

   function __construct() { }

   public static function getLogFieldsArray()
    {
     return array('logID','referer','ip','dns','userID','adminID','ts');
    }

   public static function writeLog($w3)
    {
	 $_FIELD = webmatic3::getPostValueArray(wm3Logs::getLogFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['referer'] = getenv('HTTP_REFERER');
     $_FIELD['ip']      = getenv('REMOTE_ADDR');
     $_FIELD['dns']     = gethostbyaddr($_FIELD['ip']);
     $_FIELD['userID']  = $w3->getAuthenticateUserID();
     $_FIELD['adminID'] = $w3->getAuthenticateAdminID();
     $_FIELD['ts']      = time();
     $w3->getDBObj()->saveAllTableFields('_logs',$_FIELD);
    }

   public static function getLogList($w3,$currentID = 0,$admin = true)
    {
     // Get logs list (admin side)

     // Prepare variables to create the list
     $max_page_items = 65;
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE referer LIKE '%$filter%'
	                       OR dns     LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_logs.ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_logs $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'logID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&logID=$row->logID";
	   $date = wm3Util::renderDate($w3,$row->ts,$w3->getAdminLanguage());
	   $ip = "<b>".$row->ip."</b><br>";
	   if($row->userID  == WM3_cUSER_ANONYMOUS) $user_login  = $w3->getWord(988); else $user_login  = wm3User::getUserLogin($w3,$row->userID);
	   if($row->adminID == WM3_cUSER_ANONYMOUS) $admin_login = '';                else $admin_login = wm3User::getUserLogin($w3,$row->adminID);
	   $ip .= "User $user_login"; if($admin_login) $ip .= "<br>Admin $admin_login";
	   $referer = "<a href=\"$row->referer\">$row->referer</a>";
       $_DATA[$p]->date    = $date;
       $_DATA[$p]->ip      = $ip;
       $_DATA[$p]->dns     = $row->dns;
       $_DATA[$p]->referer = $referer;
       // Buttons
       $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_LOG,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
       if($row->logID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     if($admin) {
                 $_SEP = $w3->getSkinObj()->getSeparator();
                 $list->setTitle($w3->getWord(1248)." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_DELETE_ALL_LOG,"action_delete_mini.png","",$w3->getWord(1256),$w3->getWord(1255),0,16,16));
		         require(WM3_cPATH_INCLUDE.'admin_log_search_form.inc');
		         $list->setSearchForm($search_form);
		         if($found) $list->setCurrentID($currentID);
		         $list->setMaxPageItems($max_page_items);
                 $list->setPage($pg);
                 $list->setPagesNavigatorLink($base_link.$id_link.$search_link."&action=".WM3_cACTION_SHOW_LOG);
                 $list->setCaptionLabels(array($w3->getWord(807),$w3->getWord(1671),$w3->getWord(53),$w3->getWord(225)));
                 $list->setCaptionWidths(array(10,8,36,46));
                 $list->setCaptionColspan(array(1,1,1,1,1));
                 $list->setWidths(array(10,8,36,46));
			    }
     else       {
		         $list->setTitle('');
		         $list->setRenderCaption(false);
		         $list->setRenderPagesNavigator(false);
                 $list->setWidths(array(10,8,36,46));
                }
     return $list->render();
    }

   public static function deleteLog($w3,$logID)
    {
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_logs WHERE logID = '$logID'");
	}

   public static function deleteLogAll($w3)
    {
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_logs");
	}

  }

?>
