<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3User
  {

   function __construct() { }

   public static function getUserFieldsArray()
    {
     return array('userID','login','password','retype_password','groupID',
                  'name','surname','avatar','address','zip_code','city','stateID','countryID','phone','fax','cell','email','website','msn','skype','icq',
                  'birth_date','gender','tax_code','vat_code','birth_city','birth_stateID','birth_countryID',
                  'enabled','special','visible','deleted','f1','f2','f3','f4','f5','f6','f7','f8','notes',
                  'admin',
                  'af1' ,'af2' ,'af3' ,'af4' ,'af5' ,'af6' ,'af7' ,'af8' ,'af9' ,'af10',
                  'af11','af12','af13','af14','af15','af16','af17','af18','af19','af20',
                  'af21','af22','af23','af24','af25','af26','af27','af28','af29','af30',
                  'af31','af32','af33','af34','af35','af36','af37','af38','af39','af40',
                  'superuser','languageID','last_user_login_ts','previous_user_login_ts','last_admin_login_ts','previous_admin_login_ts','ts');
    }

   public static function getUserPasswordFieldsArray()
    {
     return array('old_password','password','retype_password','send_email');
    }

   public static function getGroupFieldsArray()
    {
     return array('groupID','name','description','enabled','icon','languageID','ts');
    }

   public static function executeHomeAction($w3)
    {
     switch($w3->getAction())
      {
       default:
        {
         return wm3User::addUserRegistration($w3);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_EDIT_PASSWORD_USER:
        {
         return wm3User::editUserPassword($w3);
         break;
        }
       case WM3_cACTION_DISABLE_USER:
        {
		 if(wm3User::isSuperUser($w3,$w3->getVariable('userID','get')))
		  return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         wm3User::disableUser($w3,$w3->getVariable('userID','get'));
         return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_USER:
        {
		 if(wm3User::isSuperUser($w3,$w3->getVariable('userID','get')))
		  return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         wm3User::enableUser($w3,$w3->getVariable('userID','get'));
         return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         break;
        }
/*       case WM3_cACTION_DELETE_USER:
        {
		 if(wm3User::isSuperUser($w3,$w3->getVariable('userID','get')))
		  return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         wm3User::deleteUser($w3,$w3->getVariable('userID','get'));
         return wm3User::getUserList($w3);
         break;
        }*/
       case WM3_cACTION_ADD_USER:
        {
         return wm3User::addUser($w3);
         break;
        }
       case WM3_cACTION_EDIT_USER:
        {
		 if(wm3User::isSuperUser($w3,$w3->getVariable('userID','get')))
		  return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         return wm3User::editUser($w3);
         break;
        }
       case WM3_cACTION_DELETE_GROUP:
        {
         wm3User::deleteGroup($w3,$w3->getVariable('groupID','get'));
         return wm3User::getGroupList($w3);
         break;
        }
       case WM3_cACTION_ADD_GROUP:
        {
         return wm3User::addGroup($w3);
         break;
        }
       case WM3_cACTION_EDIT_GROUP:
        {
         return wm3User::editGroup($w3);
         break;
        }
       case WM3_cACTION_SHOW_GROUP:
        {
         return wm3User::getGroupList($w3);
        }
       default:
        {
         return wm3User::getUserList($w3);
        }
      }
    }

   public static function executeUserInformationUserAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_EDIT_USER:
        {
         return wm3User::editUserInformation($w3,false);
         break;
        }
       case WM3_cACTION_EDIT_PASSWORD_USER:
        {
         return wm3User::editUserInformationPassword($w3,false);
         break;
        }
       default:
        {
         return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateUserID());
        }
      }
    }

   public static function executeUserInformationAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_EDIT_USER:
        {
         return wm3User::editUserInformation($w3);
         break;
        }
       case WM3_cACTION_EDIT_PASSWORD_USER:
        {
         return wm3User::editUserInformationPassword($w3);
         break;
        }
       default:
        {
         return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateAdminID());
        }
      }
    }

   public static function getSectionUserDataArray($w3)
    {
     $_DATA['img']     = array('icon_home_user.png','icon_news.png','','','icon_forum.png','icon_banners.png','icon_market.png',);
     $_DATA['alt']     = array($w3->getWord(501),$w3->getWord(511),'','',$w3->getWord(973),$w3->getWord(510),$w3->getWord(509));
	 // If render its enabled the icon will be render into the menu
     $_DATA['render']  = array(WM3_cENABLED,WM3_cENABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED);
	 // Section offsets (set correct section numbers for user side)
     $_DATA['section'] = array(WM3_cSECTION_HOME,WM3_cSECTION_NEWS,0,0,WM3_cSECTION_FORUMS,WM3_cSECTION_BANNERS,WM3_cSECTION_MARKET);
     return $_DATA;
    }

   public static function getSectionAdminDataArray($w3)
    {
     $_DATA['img']     = array('icon_home_admin.png','icon_news.png','icon_pages.png','icon_users.png','icon_menu.png','icon_panels.png','icon_channels.png','icon_messages.png','icon_links.png','icon_faq.png','icon_searchengine.png','icon_newsletter.png','icon_surveys.png','icon_horoscope.png','icon_forum.png','icon_downloads.png','icon_albums.png','icon_directories.png','icon_ecommerce.png','icon_market.png','icon_banners.png','icon_webmail.png','icon_folders.png','icon_preferences.png','icon_metatags.png','icon_statistics.png','icon_languages.png');
     $_DATA['alt']     = array($w3->getWord(501),$w3->getWord(511),$w3->getWord(518),$w3->getWord(513),$w3->getWord(519),$w3->getWord(516),$w3->getWord(517),$w3->getWord(515),$w3->getWord(512),$w3->getWord(506),$w3->getWord(507),$w3->getWord(508),$w3->getWord(835),$w3->getWord(514),$w3->getWord(1375),$w3->getWord(1036),$w3->getWord(1335),$w3->getWord(1037),$w3->getWord(656),$w3->getWord(509),$w3->getWord(510),$w3->getWord(1454),$w3->getWord(1374),$w3->getWord(27),$w3->getWord(1373),$w3->getWord(54),$w3->getWord(1291));
	 // If render its enabled the icon will be render into the menu
	 $_DATA['render']  = array(WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cENABLED);
	 // Section offsets (set correct section numbers for user side)
	 $_DATA['section'] = array(WM3_cSECTION_HOME,WM3_cSECTION_NEWS,WM3_cSECTION_PAGES,WM3_cSECTION_USERS,WM3_cSECTION_MENUS,WM3_cSECTION_PANELS,WM3_cSECTION_CHANNELS,WM3_cSECTION_MESSAGES,WM3_cSECTION_LINKS,WM3_cSECTION_FAQ,WM3_cSECTION_SEARCH_ENGINE,WM3_cSECTION_NEWSLETTER,WM3_cSECTION_SURVEYS,WM3_cSECTION_HOROSCOPE,WM3_cSECTION_FORUMS,WM3_cSECTION_DOWNLOADS,WM3_cSECTION_MEDIA_ALBUMS,WM3_cSECTION_DIRECTORIES,WM3_cSECTION_ECOMMERCE,WM3_cSECTION_MARKET,WM3_cSECTION_BANNERS,WM3_cSECTION_WEBMAIL,WM3_cSECTION_FOLDERS,WM3_cSECTION_PREFERENCES,WM3_cSECTION_METATAGS,WM3_cSECTION_STATISTICS,WM3_cSECTION_LANGUAGES); 
     return $_DATA;
    }

   public static function setUserCookies($w3)
    {
     // User authentication (return the userID of logged user)

     if(!isset($_COOKIE['user_login']) || !isset($_COOKIE['user_password']))
      {
       // Admin login or password cookies not set
       if(!isset($_POST['user_login']) || !isset($_POST['user_password'])) return WM3_cUSER_ANONYMOUS;
       if($_POST['user_login'] == "" || $_POST['user_password'] == "")     return WM3_cUSER_ANONYMOUS;

       if(md5($_POST['user_password']) == wm3User::getUserPassword($w3,$_POST['user_login']))
        {
         // Login and password check its passed, can set cookies and update login time stamp
         setcookie("user_login",    $_POST['user_login']);
         setcookie("user_password", md5($_POST['user_password']));
         $userID = wm3User::getUserIDFromLogin($w3,$_POST['user_login']);
         wm3User::setUserLastLoginTimeStamp($w3,$userID);
         return $userID;
        }
      }
     else
      {
       // Cookies already set, check it and return logged userID if check passed
       if($_COOKIE['user_password'] == wm3User::getUserPassword($w3,$_COOKIE['user_login'])) return wm3User::getUserIDFromLogin($w3,$_COOKIE['user_login']);
       else {
		     // Remove the bad cookie (useful when password changes)
			 setcookie("user_login",   "",time()-3600);
		     setcookie("user_password","",time()-3600);
	        }
      }
     return 0;
    } 

   public static function setAdminCookies($w3)
    {
     // Admin authentication (return the userID of logged administrator)
     
     if(!isset($_COOKIE['admin_login']) || !isset($_COOKIE['admin_password']))
      {
       // Admin login or password cookies not set
       if(!isset($_POST['admin_login']) || !isset($_POST['admin_password'])) return WM3_cUSER_ANONYMOUS;
       if($_POST['admin_login'] == "" || $_POST['admin_password'] == "")     return WM3_cUSER_ANONYMOUS;

       if(md5($_POST['admin_password']) == wm3User::getAdminPassword($w3,$_POST['admin_login']))
        {
         // Login and password check its passed, can set cookies and update login time stamp
         setcookie("admin_login",    $_POST['admin_login']);
         setcookie("admin_password", md5($_POST['admin_password']));
         $userID = wm3User::getUserIDFromLogin($w3,$_POST['admin_login']);
         wm3User::setAdminLastLoginTimeStamp($w3,$userID);
         return $userID;
        }
      }
     else
      {
       // Cookies already set, check it and return logged userID if check passed
       if($_COOKIE['admin_password'] == wm3User::getAdminPassword($w3,$_COOKIE['admin_login'])) return wm3User::getUserIDFromLogin($w3,$_COOKIE['admin_login']);
       else {
		     // Remove the bad cookie (useful when password changes)
			 setcookie("admin_login",   "",time()-3600);
		     setcookie("admin_password","",time()-3600);
	        }
      }
     return 0;
    } 

   public static function checkUserAuthentication($w3)
    {
     // Check User authentication cookies (return the userID of logged user)

     // User login or password cookies not set     
     if(!isset($_COOKIE['user_login']) || !isset($_COOKIE['user_password'])) return WM3_cUSER_ANONYMOUS;
     else
      {
       // Cookies already set, check it and return logged userID if check passed
       if($_COOKIE['user_password'] == wm3User::getUserPassword($w3,$_COOKIE['user_login'])) return wm3User::getUserIDFromLogin($w3,$_COOKIE['user_login']);
      }
     return WM3_cUSER_ANONYMOUS;
    }

   public static function checkAdminAuthentication($w3)
    {
     // Check Admin authentication cookies (return the userID of logged administrator)

     // Admin login or password cookies not set     
     if(!isset($_COOKIE['admin_login']) || !isset($_COOKIE['admin_password'])) return WM3_cUSER_ANONYMOUS;
     else
      {
       // Cookies already set, check it and return logged userID if check passed
       if($_COOKIE['admin_password'] == wm3User::getAdminPassword($w3,$_COOKIE['admin_login'])) return wm3User::getUserIDFromLogin($w3,$_COOKIE['admin_login']);
      }
     return WM3_cUSER_ANONYMOUS;
    }

   public static function isSuperUser($w3,$userID)
    {
     // Check if the user its superuser
     $rs = $w3->getDBObj()->query("SELECT superuser FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->superuser;
    }

   public static function isAdministrator($w3,$userID)
    {
     // Check if the user its superuser
     $rs = $w3->getDBObj()->query("SELECT admin FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->admin;
    }

   public static function getUserIDFromLogin($w3,$login)
    {
     // Return userID from login
     $rs = $w3->getDBObj()->query("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE login = '$login'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->userID;
    } 

   public static function getUserIDFromEmail($w3,$email)
    {
     // Return userID from email
     $rs = $w3->getDBObj()->query("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE email = '$email'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->userID;
    } 

   public static function getUserLogin($w3,$userID)
    {
     // Return login from userID
     $rs = $w3->getDBObj()->query("SELECT login FROM ".WM3_cCONFIG_DB_PREFIX."_users
                                   WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return '';
     $row = $w3->getDBObj()->fetch($rs);
     return $row->login;
    }

   public static function getUserLastLoginTimeStamp($w3,$userID,$previous = false)
    {
     // Return last user login time stamp from userID
     $rs = $w3->getDBObj()->query("SELECT last_user_login_ts,previous_user_login_ts FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0; // Never logged
     $row = $w3->getDBObj()->fetch($rs);
     if($previous) return $row->previous_user_login_ts;
	 else          return $row->last_user_login_ts;
    }

   public static function getAdminLastLoginTimeStamp($w3,$userID,$previous = false)
    {
     // Return last admin login time stamp from userID
     $rs = $w3->getDBObj()->query("SELECT last_admin_login_ts,previous_admin_login_ts FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0; // Never logged
     $row = $w3->getDBObj()->fetch($rs);
     if($previous) return $row->previous_admin_login_ts;
	 else          return $row->last_admin_login_ts; 
    }

   public static function setUserLastLoginTimeStamp($w3,$userID)
    {
     // Update user login timestap when an user do the login
     $ts = time();
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET   previous_user_login_ts  = last_user_login_ts,
					         last_user_login_ts      = '$ts'
                       WHERE userID                  = '$userID'");
    }

   public static function setAdminLastLoginTimeStamp($w3,$userID)
    {
     // Update admin login timestap when an administrator do the login
     $ts = time();
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET   previous_admin_login_ts  = last_admin_login_ts,
					         last_admin_login_ts      = '$ts'
                       WHERE userID                   = '$userID'");
    }

   public static function logoutUser()
    {
     setcookie("user_login",   "",time()-3600);
     setcookie("user_password","",time()-3600);
     header("Location: ".WM3_cCONFIG_HOME_FILE); // Redirect to home page
     die;
    }

   public static function logoutAdmin()
    {
     setcookie("admin_login",   "",time()-3600);
     setcookie("admin_password","",time()-3600);
     header("Location: ".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN); // Redirect to admin login panel
     die;
    }

   public static function getUserPassword($w3,$login)
    {
     $rs = $w3->getDBObj()->query("SELECT password FROM ".WM3_cCONFIG_DB_PREFIX."_users
                                   WHERE login = '".wm3Util::quoteDB($login)."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."'");
     if($w3->getDBObj()->totalRows($rs)!=0)
      {
       $row=$w3->getDBObj()->fetch($rs);
       return $row->password;
      }
     return "";
    }

   public static function getAdminPassword($w3,$login)
    {
     $rs = $w3->getDBObj()->query("SELECT password FROM ".WM3_cCONFIG_DB_PREFIX."_users
                                   WHERE login = '".wm3Util::quoteDB($login)."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."' AND admin = '".WM3_cENABLED."'");
     if($w3->getDBObj()->totalRows($rs)!=0)
      {
       $row=$w3->getDBObj()->fetch($rs);
       return $row->password;
      }
     return "";
    }

   public static function getPageUserInfo($w3,$pageID)
    {
     // User info page content
     $userID = $w3->getVariable('userID','get');
     if($userID) return wm3User::getSingleUserInformation($w3,$pageID,$userID);
     else        return wm3User::getAllUsersInformation($w3,$pageID);
    }

   public static function getAllUsersInformation($w3,$pageID)
    {
     // Get users list (home side)

     // Prepare variables to create the list
     $max_page_items = 12;
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE login LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     $search_form_link = WM3_cCONFIG_HOME_FILE."?pageID=$pageID";
	 $base_link = WM3_cCONFIG_HOME_FILE."?section=".$w3->getSection()."&pageID=$pageID";
	 if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USERS;
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY userID";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,0,$total_items,$max_page_items,$pg,'userID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link."&userID=$row->userID";
	   if($allowed) $allowed_link = $base_allowed_link."&userID=$row->userID";
       $avatar = "<a href=\"$link\">".wm3Util::renderImg($row->avatar,'',36,36,WM3_cPATH_AVATARS,1)."</a>";
	   $group_name = wm3User::getGroupName($w3,$row->groupID);
	   if(wm3Session::getSessionIDFromUserID($w3,$row->userID)) $online = wm3Util::renderImg("misc_online.png")." online";
	   else                                                 $online = wm3Util::renderImg("misc_offline.png")." offline";
       $info = "<a href=\"$link\">$row->login</a> ($group_name)<br><br>$online";
	   $last_user_login  = wm3Util::renderDate($w3,wm3User::getUserLastLoginTimeStamp($w3,$row->userID),$w3->getAdminLanguage(),false,"Never logged")." (user)";
	   if($row->admin) $last_admin_login = wm3Util::renderDate($w3,wm3User::getAdminLastLoginTimeStamp($w3,$row->userID),$w3->getAdminLanguage(),false,"Never logged")." (admin)";
	   else            $last_admin_login = '';
	   $last_login = $last_user_login."<br>".$last_admin_login;
	   $rank       = wm3User::renderRank($w3,$row->userID);
   	   $admin_pic  = wm3Util::renderImg('misc_user.png',$w3->getWord(-1).'Standard user');
       if($row->admin)     $admin_pic = wm3Util::renderImg('misc_admin.png',$w3->getWord(998));
       if($row->superuser) $admin_pic = wm3Util::renderImg('misc_superuser.png',$w3->getWord(-1).'Superuser');
	   $rank = "<nobr>".$rank." ".$admin_pic."</nobr>";
	   $vitality = "<nobr>".wm3User::renderVitality($w3,$row->userID)."</nobr>";
       $_DATA[$p]->avatar          = $avatar;
       $_DATA[$p]->info            = $info;
       $_DATA[$p]->rank            = $rank;
       $_DATA[$p]->vitality        = $vitality;
       $_DATA[$p]->last_user_login = $last_user_login;
       $_DATA[$p]->last_login      = $last_login;
       // Buttons
	   if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178));
	   $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,"Users list");
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_user_search_form.inc');
     $list->setSearchForm($search_form);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(403),$w3->getWord(416),$w3->getWord(902),$w3->getWord(899),$w3->getWord(900)));
     $list->setCaptionWidths(array(0,15,15,15,25,30));
     $list->setCaptionColspan(array(2,1,1,1,1,1));
     $list->setWidths(array(0,15,15,15,25,30));
     return $list->render();
    }

   public static function getSingleUserInformation($w3,$pageID,$userID,$bottom = true)
    {
	 // Prepare variables
 	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS); // Used to enable admin buttons in home stage
/*     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE body LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     $search_form_link = WM3_cCONFIG_HOME_FILE;
     $pageID = $w3->getVariable('pageID','get');*/
     $base_link = WM3_cCONFIG_HOME_FILE."?section=".$w3->getSection();
	 if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USERS;
     $id_link = '';
     $link = '';

     // Do the query and take the total items number
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users WHERE userID = '$userID'");
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create item
     $_DATA = $_COLSPAN = array();
     $row = $w3->getDBObj()->fetch($rs);
     if($row)
      {
       // User main info
       $link = $base_link.$id_link;
	   if($allowed) $allowed_link = $base_allowed_link."&userID=$row->userID";
	   $group_name = wm3User::getGroupName($w3,$row->groupID);
	   $rank = wm3User::renderRank($w3,$row->userID);
       $admin_pic  = wm3Util::renderImg('misc_user.png',$w3->getWord(-1).'Standard user');
       if($row->admin)     $admin_pic = wm3Util::renderImg('misc_admin.png',$w3->getWord(998));
       if($row->superuser) $admin_pic = wm3Util::renderImg('misc_superuser.png',$w3->getWord(-1).'Superuser');
	   $rank     = "<nobr>".$rank." ".$admin_pic."</nobr>";
	   $vitality = "<nobr>".wm3User::renderVitality($w3,$row->userID,180)."</nobr>";
       if(wm3Session::getSessionIDFromUserID($w3,$row->userID)) $online = wm3Util::renderImg("misc_online.png")." online";
	   else                                                 $online = wm3Util::renderImg("misc_offline.png")." offline";
       $avatar   = "<img src=\"".WM3_cPATH_AVATARS."$row->avatar\" width=\"36\" height=\"36\" border=\"1\" align=\"absmiddle\"> ";
       $buttons = '';
	   if($w3->getAuthenticateUserID())
	    if(wm3User::checkUserPermission($w3,3) && $row->f3 == WM3_cENABLED)
	     $buttons = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_USER_MESSAGES."&action=".WM3_cACTION_ADD_USER_MESSAGE."&toID=".$row->userID,"action_newsletter.png",$w3->getWord(178),"","",0,16,16)." ";
	   if($w3->getAuthenticateAdminID())
	    if($row->f3 == WM3_cENABLED)
	     $buttons = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USER_MESSAGES."&action=".WM3_cACTION_ADD_USER_MESSAGE."&toID=".$row->userID,"action_newsletter.png",$w3->getWord(178),"","",0,16,16)." ";
       $pic         = $avatar."<br><br><nobr>$buttons</nobr><br>";
	   $member_from = "<i>".$w3->getWord(899)." ".wm3Util::renderDate($w3,$row->ts,$w3->getAdminLanguage())."</i>";
	   //$login    = "<a href=\"$link&pageID=$pageID&userID=$row->userID\">$row->login</a> <b>($group_name)</b><br>$member_from<br><br>$rank<br><br>$vitality<br><br>$online<br><br>";
	   $login       = "$row->login <b>($group_name)</b><br>$member_from<br><br>$rank<br><br>$vitality<br><br>$online<br><br>";
	   $_DATA[0]->avatar = $pic;
	   $_DATA[0]->login  = $login;
	   if($allowed) $_DATA[0]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178));

       // Extra info
	   $last_user_login  = wm3Util::renderDate($w3,wm3User::getUserLastLoginTimeStamp($w3,$row->userID),$w3->getAdminLanguage(),false,"Never logged")." (user)";
	   if($row->admin) $last_admin_login = wm3Util::renderDate($w3,wm3User::getAdminLastLoginTimeStamp($w3,$row->userID),$w3->getAdminLanguage(),false,"Never logged")." (admin)";
	   else            $last_admin_login = "";
	   $label = "<b>".$w3->getWord(900)."</b>";
	   if($row->admin == WM3_cENABLED) $last_login = wm3Util::renderImg("misc_log.png")." $last_user_login<br><br>".wm3Util::renderImg("misc_log_admin.png")." $last_admin_login";
	   else                            $last_login = wm3Util::renderImg("misc_log.png")." $last_user_login";
	   $_DATA[1]->label   = $label;
	   $_DATA[1]->content = $last_login."<br><br>";
       if($allowed) $_COLSPAN[1] = array(1,2);
       if($row->visible == WM3_cENABLED)
	    {
	     $label = "<b>".$w3->getWord(189)."</b>";
	     if($row->gender == 'M') $gender = wm3Util::renderImg("misc_male.png");
	     else                    $gender = wm3Util::renderImg("misc_female.png");
	     $name  = "$row->name $row->surname $gender";
	     $_DATA[2]->label   = $label;
	     $_DATA[2]->content = $name."<br><br>";
	     if($allowed) $_COLSPAN[2] = array(1,2);

	     $label   = "<b>".$w3->getWord(260)."</b>";
	     $address = wm3Util::renderImg("misc_home.png")." $row->address - $row->zip_code $row->city ($row->stateID)<br><br>".wm3Util::renderImg(wm3Statistic::getCountryFlag($w3,$row->countryID),'',20,13,WM3_cPATH_FLAGS)." ".wm3Statistic::getCountryName($w3,$row->countryID);
	     $_DATA[3]->label   = $label;
	     $_DATA[3]->content = $address."<br><br>";
	     if($allowed) $_COLSPAN[3] = array(1,2);

	     $label    = "<b>".$w3->getWord(-1)."Contacts</b>";
	     $contacts = wm3Util::renderImg("misc_phone.png")." $row->phone<br><br>".wm3Util::renderImg("misc_fax.png")." $row->fax<br><br>".wm3Util::renderImg("misc_cell.png")." $row->cell";
	     $_DATA[4]->label   = $label;
	     $_DATA[4]->content = $contacts."<br><br>";
	     if($allowed) $_COLSPAN[4] = array(1,2);

	     $label = "<b>".$w3->getWord(-1)."Web info</b>";
	     $web   = "<a href=\"$row->website\" target=\"_blank\">".wm3Util::renderImg("misc_world.png")." $row->website</a><br><br><a href=\"mailto:$row->email\">".wm3Util::renderImg("misc_email.png")." $row->email</a><br><br>".wm3Util::renderImg("misc_icq.png")." $row->icq";
	     $_DATA[5]->label   = $label;
	     $_DATA[5]->content = $web."<br><br>";
	     if($allowed) $_COLSPAN[5] = array(1,2);

	     $label = "<b>".$w3->getWord(-1)."Other info</b>";
	     if($row->birth_date == '0000-00-00') $birth_ts = 0; else $birth_ts = strtotime($row->birth_date);
	     $other = wm3Util::renderImg("misc_birthday.png")." $row->birth_city ($row->birth_stateID), ".wm3Util::renderDate($w3,$birth_ts,$w3->getAdminLanguage(),true,"No birthday given",false)."<br><br>".wm3Util::renderImg(wm3Statistic::getCountryFlag($w3,$row->birth_countryID),'',20,14,WM3_cPATH_FLAGS)." ".wm3Statistic::getCountryName($w3,$row->birth_countryID);
	     $_DATA[6]->label   = $label;
	     $_DATA[6]->content = $other."<br><br>";
	     if($allowed) $_COLSPAN[6] = array(1,2);
        }
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(896),$_COLSPAN);
     $list->setTotalItems($total_items);
     $list->setMaxPageItems(1);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(10,90));
     $list->setEmptyLabel($w3->getWord(922));
     if($bottom) $list->setBottomContent("<a href=\"$link&pageID=$pageID\">< ".$w3->getWord(923)."</a>");
     return $list->render();
    }

   public static function editUserInformationPassword($w3,$admin = true)
    {
	 // Initialize form
	 if($admin) $userID = $w3->getAuthenticateAdminID();
     else       $userID = $w3->getAuthenticateUserID();
	 $action = WM3_cACTION_EDIT_PASSWORD_USER;
	 require(WM3_cPATH_INCLUDE.'admin_user_information_password_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Change password");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '$userID'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3User::getUserPasswordFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3User::getUserPasswordFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
       if($form->validate())
        {
         if($admin)
          {
           $lastID = wm3User::updateUserInformationPassword($w3,$userID);
           $w3->getDBObj()->query("UNLOCK TABLES");
           return wm3User::getSingleUserInformation($w3,0,$userID);
          }
         else
          {
           $lastID = wm3User::updateUserInformationPassword($w3,$userID);
		   $w3->getDBObj()->query("UNLOCK TABLES");
           return wm3User::getSingleUserInformation($w3,0,$userID);
		  }
		}
	   $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function updateUserInformationPassword($w3,$userID)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserPasswordFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET password = '".md5(wm3Util::unquoteDB($_FIELD['password']))."'
                       WHERE userID = '".$userID."'");
     return $userID;
    }

   public static function editUserInformation($w3,$admin = true)
    {
	 // Initialize form
	 if($admin) { $userID = $w3->getAuthenticateAdminID(); $languageID = $w3->getAdminLanguage(); }
	 else       { $userID = $w3->getAuthenticateUserID();  $languageID = $w3->getHomeLanguage(); }
	 $action = WM3_cACTION_EDIT_USER;
	 require(WM3_cPATH_INCLUDE.'admin_user_information_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit user");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users WHERE userID = '$userID'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3User::getUserFieldsArray(),$row);

       // Default value for fields not in $row object
       $_F['birth_date']->setDate($_FIELD['birth_date']);

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());
       $form->setFieldsValues($_FIELD);
       $_F['birth_date']->setDateYMD($w3->getVariable('birth_date_year','post'),$w3->getVariable('birth_date_month','post'),$w3->getVariable('birth_date_day','post'));
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
       if($form->validate())
        {
         if($admin) $lastID = wm3User::updateUserInformation($w3);
         else       $lastID = wm3User::updateUserInformation($w3,false);
         $w3->getDBObj()->query("UNLOCK TABLES");
         if($admin) return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateAdminID());
         else       return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateUserID());
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     if(wm3User::isSuperUser($w3,$userID)) $_F['groupID']->setEnabled(true);
     $preview_image = $_FIELD['avatar'];
     $_F['avatar']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_AVATARS,1,'top','preview_image'));

     return $form->render();
    }

   public static function updateUserInformation($w3,$admin = true)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
	 if($admin) $userID = $w3->getAuthenticateAdminID();
	 else       $userID = $w3->getAuthenticateUserID();	 
	 if(wm3User::isSuperUser($w3,$userID)) $_EXTRA['groupID'] = "groupID = '".$_FIELD['groupID']."',";
	 else                                  $_EXTRA['groupID'] = "";
	 $birth_date = $w3->getVariable('birth_date_year','post').'-'.$w3->getVariable('birth_date_month','post').'-'.$w3->getVariable('birth_date_day','post');
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET   name            = '".$_FIELD['name']."',
                             surname         = '".$_FIELD['surname']."',
                             address         = '".$_FIELD['address']."',
                             zip_code        = '".$_FIELD['zip_code']."',
                             city            = '".$_FIELD['city']."',
                             stateID         = '".$_FIELD['stateID']."',
                             countryID       = '".$_FIELD['countryID']."',
                             phone           = '".$_FIELD['phone']."',
                             fax             = '".$_FIELD['fax']."',
                             cell            = '".$_FIELD['cell']."',
                             icq             = '".$_FIELD['icq']."',
                             email           = '".$_FIELD['email']."',
						     ".$_EXTRA['groupID']."
                             website         = '".$_FIELD['website']."',
                             birth_date      = '$birth_date',
                             birth_city      = '".$_FIELD['birth_city']."',
                             birth_stateID   = '".$_FIELD['birth_stateID']."',
                             birth_countryID = '".$_FIELD['birth_countryID']."',
                             gender          = '".$_FIELD['gender']."',
                             avatar          = '".$_FIELD['avatar']."'
                       WHERE userID          = '$userID'");
     return $userID;
    }

   public static function getUserList($w3,$currentID = 0,$admin = true)
    {
     // Get users list

     // Prepare variables to create the list
     $max_page_items = 15;
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE login LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY userID";
     $query    = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'userID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&userID=$row->userID";
	   $admin_pic = wm3Util::renderImg('misc_user.png',$w3->getWord(-1).'Standard user');
       if($row->admin)     $admin_pic = wm3Util::renderImg('misc_admin.png',$w3->getWord(998));
       if($row->superuser) $admin_pic = wm3Util::renderImg('misc_superuser.png',$w3->getWord(-1).'Superuser');
	   $last_user_login  = wm3Util::renderDate($w3,wm3User::getUserLastLoginTimeStamp($w3,$row->userID),$w3->getAdminLanguage(),false,"Never logged")." (user)";
	   $last_admin_login = wm3Util::renderDate($w3,wm3User::getAdminLastLoginTimeStamp($w3,$row->userID),$w3->getAdminLanguage(),false,"Never logged")." (administrator)";
       $_DATA[$p]->login      = "$admin_pic <a href=\"mailto:$row->email\">$row->login</a>";
       $_DATA[$p]->info       = "$row->name $row->surname";
       $_DATA[$p]->last_login = "$last_user_login<br>$last_admin_login";
       // Buttons
	   if(!$row->superuser)
	    {
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_USER,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_USER,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178));
		 $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_PASSWORD_USER,"action_password.png",$w3->getWord(-1)."Change password");
         $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_USER,"action_delete.png",$w3->getWord(179),$w3->getWord(696));
		}
	   else
        {
		 $_DATA[$p]->b1 = "<img src=\"".WM3_cPATH_DATA."action_disable_inactive.png\">";
	     $_DATA[$p]->b2 = "<img src=\"".WM3_cPATH_DATA."action_edit_inactive.png\">";
		 $_DATA[$p]->b3 = "<img src=\"".WM3_cPATH_DATA."action_password_inactive.png\">";
		 $_DATA[$p]->b4 = "<img src=\"".WM3_cPATH_DATA."action_delete_inactive.png\">";
        }
       if($row->userID == $currentID && !$found) {  $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1022));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_user_search_form.inc');
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(1240),$w3->getWord(1407),$w3->getWord(900)));
     $list->setCaptionWidths(array(25,40,35));
     $list->setCaptionColspan(array(1,1,1,4));
     $list->setWidths(array(25,40,35));
     return $list->render();
    }

   public static function getGroupList($w3,$currentID = 0,$admin = true)
    {
     // Get groups list
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_groups ORDER BY groupID";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link."&groupID=$row->groupID";
       if($row->groupID == '1') $label_default = "(".$w3->getWord(647).")"; else $label_default = "";
       $_DATA[$p]->nome = $row->name;
       $_DATA[$p]->description = $row->description;
       $_DATA[$p]->info = wm3Util::renderDate($w3,$row->ts,$w3->getAdminLanguage(),false)." $label_default<br>(GroupID <b>#$row->groupID</b>)";
       // Buttons
       if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_GROUP,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_GROUP,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_GROUP,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_GROUP,"action_delete.png",$w3->getWord(179),$w3->getWord(1253));
       if($row->groupID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1249));
     $list->setTotalItems($total_items);
     if($found) $list->setCurrentID($currentID);
     $list->setCaptionLabels(array($w3->getWord(189),$w3->getWord(227),$w3->getWord(1407)));
     $list->setCaptionWidths(array(25,45,30));
     $list->setCaptionColspan(array(1,1,1,3));
     $list->setWidths(array(25,45,30));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function addUserRegistration($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());
     $_FIELD['pageID'] = $w3->getVariable('pageID'); // Take pageID from both
	 $action = 0; // No action
	 $type = $w3->getPreferences('registration_form_type');
	 if($type == WM3_cPREFERENCES_REGISTRATION_FULL)   require(WM3_cPATH_INCLUDE.'home_user_full_form.inc');
	 if($type == WM3_cPREFERENCES_REGISTRATION_NORMAL) require(WM3_cPATH_INCLUDE.'home_user_normal_form.inc');
	 if($type == WM3_cPREFERENCES_REGISTRATION_FAST)   require(WM3_cPATH_INCLUDE.'home_user_fast_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(121));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
      }
     else
      {
       if($type == WM3_cPREFERENCES_REGISTRATION_FULL) $_F['birth_date']->setDateYMD($w3->getVariable('birth_date_year','post'),$w3->getVariable('birth_date_month','post'),$w3->getVariable('birth_date_day','post'));
       if($form->validate())
        {
         $lastID = wm3User::saveUserRegistration($w3);
         return wm3User::completeUserRegistration($w3,$lastID);
		}
      }

     // Operation to do before render the form
     if($type == WM3_cPREFERENCES_REGISTRATION_FULL || $type == WM3_cPREFERENCES_REGISTRATION_NORMAL)
      {
       $preview_image = $_FIELD['avatar'];  if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_AVATARS); // Set due preview image
       $_F['avatar']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_AVATARS,1,'top','preview_image'));
      }

     return $form->render();
    }

   public static function saveUserRegistration($w3)
    {
     if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));    	

       $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
       $type = $w3->getPreferences('registration_form_type');
       if($type == WM3_cPREFERENCES_REGISTRATION_NORMAL)
     	{
         $_FIELD['gender'] = 'M';
		}
       if($type == WM3_cPREFERENCES_REGISTRATION_FAST)
     	{
         $_FIELD['gender'] = 'M';
         $_FIELD['avatar'] = 'bsd.png';
		}
       $_FIELD['birth_date'] = $w3->getVariable('birth_date_year','post').'-'.$w3->getVariable('birth_date_month','post').'-'.$w3->getVariable('birth_date_day','post');
       $_FIELD['groupID'] = $w3->getPreferences('user_groupID');
       $_FIELD['f1'] = $w3->getPreferences('user_flag1');
       $_FIELD['f2'] = $w3->getPreferences('user_flag2');
       $_FIELD['f3'] = $w3->getPreferences('user_flag3');
       $_FIELD['f4'] = $w3->getPreferences('user_flag4');
       $_FIELD['f5'] = $w3->getPreferences('user_flag5');
       $_FIELD['f6'] = $w3->getPreferences('user_flag6');
       $_FIELD['f7'] = $w3->getPreferences('user_flag7');
       $_FIELD['f8'] = $w3->getPreferences('user_flag8');
       for($i = 1; $i <= 40; $i++) $_FIELD['af'.$i] = 0;
	   $_FIELD['special'] = $w3->getPreferences('user_special');
       $_FIELD['enabled'] = $w3->getPreferences('user_enabled');
       $_FIELD['deleted'] = $_FIELD['admin'] = $_FIELD['superuser'] = 0;
	   $_FIELD['password'] = md5(wm3Util::unquoteDB($_FIELD['password']));
       $_FIELD['ts'] = time();
       $w3->getDBObj()->saveAllTableFields('_users',$_FIELD,array('retype_password'));
      }
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function completeUserRegistration($w3,$lastID)
    {
	 $w3->getPageObj()->setRenderHeadFoot(false);
     if($lastID)
      {
       $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);

       $sender     = $w3->getPreferences('service_email');
       $subject    = $w3->getPreferencesContents('user_registration_email_subject');
       $email_body = "Registration to ".$w3->getPreferences('site_address')." successfully completed.\n\nThese are your registration data:\n\n- Login: ".$_FIELD['login']."\n- Password: ".wm3Util::renderContent($w3,wm3Util::unquoteDB($_FIELD['password']),WM3_cRENDER_MODE_PLAIN_TEXT)."\n\n".$w3->getPreferencesContents('user_registration_email_text');
       $to         = $_FIELD['email'];
       $sended     = @mail($to,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
	   $home_content = "Registration successfully completed.<br>These are your registration data:<br><br>- Login: <b>".$_FIELD['login']."</b><br>- Password: <b>".wm3Util::renderContent($w3,wm3Util::unquoteDB($_FIELD['password']),WM3_cRENDER_MODE_PLAIN_TEXT)."</b>";
	   if($sended) {
                    $home_content .= "<br><br>An email with your registration data sended to <b>".$_FIELD['email']."</b>";
                    $home_content .= "<br><br> <a href=\"".WM3_cCONFIG_HOME_FILE."\">Return to homepage</a>";
		           }
	   else        {
			        $home_content .= "<br><br>Email send error. Your registration data was not sended to your address <b>\"".$_FIELD['email']."\"</b> but registration its complete.";
					$home_content .= "<br><br> <a href=\"".WM3_cCONFIG_HOME_FILE."\">Return to homepage</a>";
		           }
      }
     else
      {
       $home_content = "Errore di registrazione.";//TODO o cosa? (già registrato)
      }
     return $home_content;
    }

   public static function addUser($w3)
    {
	 // Initialize form
	 $userID = 0;
     $_DATA = wm3User::getSectionAdminDataArray($w3);
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());
     $action = WM3_cACTION_ADD_USER;
	 require(WM3_cPATH_INCLUDE.'admin_user_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(121));
     $form->setFieldsValues($_FIELD);
     $_F['password']->setEnabled(true);
     $_F['retype_password']->setEnabled(true);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       $_F['birth_date']->setDateYMD($w3->getVariable('birth_date_year','post'),$w3->getVariable('birth_date_month','post'),$w3->getVariable('birth_date_day','post'));
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
       if($form->validate())
        {
         $lastID = wm3User::saveUser($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3User::getUserList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['avatar'];  if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_AVATARS); // Set due preview image
     $_F['avatar']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_AVATARS,1,'top','preview_image'));

     return $form->render();
    }

   public static function editUser($w3)
    {
	 // Can not edit superuser
     $userID = $w3->getVariable('userID');
     if(wm3User::isSuperUser($w3,$userID)) return wm3User::getUserList($w3,$userID);			

     // Initialize form
     $_DATA = wm3User::getSectionAdminDataArray($w3);
	 $action = WM3_cACTION_EDIT_USER;
	 require(WM3_cPATH_INCLUDE.'admin_user_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit user");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '$userID'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3User::getUserFieldsArray(),$row);

       // Default value for fields not in $row object
       $_F['birth_date']->setDate($_FIELD['birth_date']);

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());
       $form->setFieldsValues($_FIELD);
       $_F['birth_date']->setDateYMD($w3->getVariable('birth_date_year','post'),$w3->getVariable('birth_date_month','post'),$w3->getVariable('birth_date_day','post'));
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
       if($form->validate())
        {
         $lastID = wm3User::updateUser($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3User::getUserList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['avatar'];
     $_F['avatar']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_AVATARS,1,'top','preview_image'));
     $_F['login']->setValue("<b>".wm3User::getUserLogin($w3,$userID)."</b>");

     return $form->render();
    }

   public static function saveUser($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['password'] = md5(wm3Util::unquoteDB($_FIELD['password']));
     $_FIELD['ts'] = time();
     $_FIELD['birth_date'] = $w3->getVariable('birth_date_year','post').'-'.$w3->getVariable('birth_date_month','post').'-'.$w3->getVariable('birth_date_day','post');
     $w3->getDBObj()->saveAllTableFields('_users',$_FIELD,array('retype_password'));
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateUser($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
	 $birth_date = $w3->getVariable('birth_date_year','post').'-'.$w3->getVariable('birth_date_month','post').'-'.$w3->getVariable('birth_date_day','post');
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET groupID         = '".$_FIELD['groupID']."',
                           name            = '".$_FIELD['name']."',
                           surname         = '".$_FIELD['surname']."',
                           address         = '".$_FIELD['address']."',
                           zip_code        = '".$_FIELD['zip_code']."',
                           city            = '".$_FIELD['city']."',
                           stateID         = '".$_FIELD['stateID']."',
                           countryID       = '".$_FIELD['countryID']."',
                           phone           = '".$_FIELD['phone']."',
                           fax             = '".$_FIELD['fax']."',
                           cell            = '".$_FIELD['cell']."',
                           icq             = '".$_FIELD['icq']."',
                           email           = '".$_FIELD['email']."',
                           website         = '".$_FIELD['website']."',
                           birth_date      = '$birth_date',
                           birth_city      = '".$_FIELD['birth_city']."',
                           birth_stateID   = '".$_FIELD['birth_stateID']."',
                           birth_countryID = '".$_FIELD['birth_countryID']."',
                           gender          = '".$_FIELD['gender']."',
                           avatar          = '".$_FIELD['avatar']."',
                           special         = '".$_FIELD['special']."',
                           enabled         = '".$_FIELD['enabled']."',
                           visible         = '".$_FIELD['visible']."',
                           deleted         = '".$_FIELD['deleted']."',
                           admin           = '".$_FIELD['admin']."',
                           f1              = '".$_FIELD['f1']."',
                           f2              = '".$_FIELD['f2']."',
                           f3              = '".$_FIELD['f3']."',
                           f4              = '".$_FIELD['f4']."',
                           f5              = '".$_FIELD['f5']."',
                           f6              = '".$_FIELD['f6']."',
                           f7              = '".$_FIELD['f7']."',
                           f8              = '".$_FIELD['f8']."',
                           af1             = '".$_FIELD['af1']."',
                           af2             = '".$_FIELD['af2']."',
                           af3             = '".$_FIELD['af3']."',
                           af4             = '".$_FIELD['af4']."',
                           af5             = '".$_FIELD['af5']."',
                           af6             = '".$_FIELD['af6']."',
                           af7             = '".$_FIELD['af7']."',
                           af8             = '".$_FIELD['af8']."',
                           af9             = '".$_FIELD['af9']."',
                           af10            = '".$_FIELD['af10']."',
                           af11            = '".$_FIELD['af11']."',
                           af12            = '".$_FIELD['af12']."',
                           af13            = '".$_FIELD['af13']."',
                           af14            = '".$_FIELD['af14']."',
                           af15            = '".$_FIELD['af15']."',
                           af16            = '".$_FIELD['af16']."',
                           af17            = '".$_FIELD['af17']."',
                           af18            = '".$_FIELD['af18']."',
                           af19            = '".$_FIELD['af19']."',
                           af20            = '".$_FIELD['af20']."',
                           af21            = '".$_FIELD['af21']."',
                           af22            = '".$_FIELD['af22']."',
                           af23            = '".$_FIELD['af23']."',
                           af24            = '".$_FIELD['af24']."',
                           af25            = '".$_FIELD['af25']."',
                           af26            = '".$_FIELD['af26']."',
                           af27            = '".$_FIELD['af27']."',
                           af28            = '".$_FIELD['af28']."',
                           af29            = '".$_FIELD['af29']."',
                           af30            = '".$_FIELD['af30']."',
                           af31            = '".$_FIELD['af31']."',
                           af32            = '".$_FIELD['af32']."',
                           af33            = '".$_FIELD['af33']."',
                           af34            = '".$_FIELD['af34']."',
                           af35            = '".$_FIELD['af35']."',
                           af36            = '".$_FIELD['af36']."',
                           af37            = '".$_FIELD['af37']."',
                           af38            = '".$_FIELD['af38']."',
                           af39            = '".$_FIELD['af39']."',
                           af40            = '".$_FIELD['af40']."',
                           notes           = '".$_FIELD['notes']."'
                       WHERE userID        = '".$_FIELD['userID']."'");
     return $_FIELD['userID'];
    }

   public static function editUserPassword($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_PASSWORD_USER;
	 require(WM3_cPATH_INCLUDE.'admin_user_password_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Change password");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '".$w3->getVariable('userID')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3User::getUserPasswordFieldsArray(),$row);

       // Default value for fields not in $row object
       $_FIELD['userID']     = $w3->getVariable('userID'); // Take userID from both
	   $_FIELD['send_email'] = WM3_cENABLED;

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3User::getUserPasswordFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
       if($form->validate())
        {
         $lastID = wm3User::updateUserPassword($w3,$w3->getVariable('userID'));
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3User::getUserList($w3,$w3->getVariable('userID'));
		}
	   $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     $_F['userID']->setValue($w3->getVariable('userID')); // Take userID from both

     return $form->render();
    }

   public static function updateUserPassword($w3,$userID)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserPasswordFieldsArray(),WM3_cQUOTE_DB);
	 if(wm3User::isSuperUser($w3,$userID)) return 0;
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET password = '".md5(wm3Util::unquoteDB($_FIELD['password']))."'
                       WHERE userID = '".$userID."'");
     return $userID;
    }

   public static function disableUser($w3,$userID) { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET enabled = '".WM3_cDISABLED."' WHERE userID = '$userID'"); }

   public static function enableUser($w3,$userID)  { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET enabled = '".WM3_cENABLED."'  WHERE userID = '$userID'"); }

//   public static function deleteUser($w3,$pageID)  { $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$pageID'"); }

   public static function addGroup($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3User::getGroupFieldsArray());
	 $action = WM3_cACTION_ADD_GROUP;
	 require(WM3_cPATH_INCLUDE.'admin_group_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1246));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3User::saveGroup($w3);
         return wm3User::getGroupList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function editGroup($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_GROUP;
	 require(WM3_cPATH_INCLUDE.'admin_group_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit group");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_groups
                               WHERE groupID = '".$w3->getVariable('groupID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3User::getGroupFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3User::getGroupFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3User::updateGroup($w3);
         return wm3User::getGroupList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function saveGroup($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getGroupFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_groups',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateGroup($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getGroupFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_groups
                       SET name        = '".$_FIELD['name']."',
                           description = '".$_FIELD['description']."',
                           enabled     = '".$_FIELD['enabled']."'
                       WHERE groupID   = '".$_FIELD['groupID']."'");
     return $_FIELD['groupID'];
    }

   public static function deleteGroup($w3,$groupID)
    {
     if($groupID != 1) // Default group (with groupID = 1) can not be deleted TODO fare come campo default in database???
      {
       $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_groups WHERE groupID = '$groupID'");
       // Update also all the tables that have groupID as field
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages set groupID = '1' WHERE groupID = '$groupID'");
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users set groupID = '1' WHERE groupID = '$groupID'");
      }
    }

   public static function writeSuperUser($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();

     $query = new wm3DBInsertInto('_users',
     array('groupID','countryID','stateID','birth_countryID','birth_stateID','login','password','name','surname','address','zip_code','city','phone','fax','cell','icq','email','website','birth_date','birth_city','gender','avatar','special','enabled','visible','deleted','admin','superuser','f1','f2','f3','f4','f5','f6','f7','f8','last_user_login_ts','previous_user_login_ts','af1','af2','af3','af4','af5','af6','af7','af8','af9','af10','af11','af12','af13','af14','af15','af16','af17','af18','af19','af20','af21','af22','af23','af24','af25','af26','af27','af28','af29','af30','af31','af32','af33','af34','af35','af36','af37','af38','af39','af40','last_admin_login_ts','previous_admin_login_ts','notes','languageID','ts'),
     array(1,
           0,0,0,0,
           $_FIELD['login'],
           md5($_FIELD['password']),
           $_FIELD['name'],
           $_FIELD['surname'],
           '','','',0,0,'','',
           $_FIELD['email'],
           '','0','','M','tux.png',
           1,1,0,0,1,1,
           1,1,1,1,1,1,1,1,
           0,0,
           1,1,1,1,1,1,1,1,1,1,
           1,1,1,1,1,1,1,1,1,1,
           1,1,1,1,1,1,1,1,1,1,
           1,1,1,1,1,1,1,1,1,1,
           0,0,'',WM3_cLANGUAGE_ALL,$_FIELD['ts']));
     $w3->getDBObj()->query($query);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function existSuperUser()
    {
     // Return true if exist the super user (used in setup only)
     $db = new wm3DB(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME,WM3_cCONFIG_DB_PREFIX);
     $rs = $db->query("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_users WHERE superuser = '1'");
     if($db->totalRows($rs) == 1) { $db->close(); return true;  }
     else                         { $db->close(); return false; }
    } 

   public static function existUser($w3,$userID)
    {
     // Return true if exist the user with userID
     $rs = $w3->getDBObj()->query("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true; else return false;
    }

   public static function checkUserPermission($w3,$fl)
    {
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '".$w3->getAuthenticateUserID()."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."'");
     if($w3->getDBObj()->totalRows($rs) != 1) return false;
     $row = $w3->getDBObj()->fetch($rs);
     $field = "f$fl";
     if($row->$field) return true; else return false;
    }

   public static function checkAdminPermission($w3,$fl)
    {
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '".$w3->getAuthenticateAdminID()."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."' AND admin = '".WM3_cENABLED."'");
     if($w3->getDBObj()->totalRows($rs) != 1) return false;
     $row = $w3->getDBObj()->fetch($rs);
     $field = "af$fl";
     if($row->$field) return true; else return false;
    }

   public static function selectState($w3)
    {
     // Return an array of wm3GUIOption objects for state select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT ".WM3_cCONFIG_DB_PREFIX."_states.*, ".WM3_cCONFIG_DB_PREFIX."_countries.name AS country_name
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_states, ".WM3_cCONFIG_DB_PREFIX."_countries
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_states.countryID = ".WM3_cCONFIG_DB_PREFIX."_countries.countryID
                             ORDER BY countryID, ".WM3_cCONFIG_DB_PREFIX."_countries.name, ".WM3_cCONFIG_DB_PREFIX."_states.name");
     array_push($array,new wm3GUIOption($w3->getWord(913),'0'));
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption($row->name." ($row->country_name)",$row->stateID));
     return $array;
    }

   public static function selectCountry($w3)
    {
     // Return an array of wm3GUIOption objects for country select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_countries
                             ORDER BY name");
     array_push($array,new wm3GUIOption($w3->getWord(914),'0'));
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption($row->name,$row->countryID));
     return $array;
    }

   public static function selectUser($w3)
    {
     // Return an array of wm3GUIOption objects for users select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users ORDER BY superuser DESC, login");
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption($row->login,$row->userID));
     return $array;
    }

   public static function selectGroup($w3,$any = false,$any_label = '')
    {
     // Return an array of wm3GUIOption objects for user groups select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_groups");
	 if($any) array_push($array,new wm3GUIOption($w3->getWord($any_label),0));
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption($row->name,$row->groupID));
     return $array;
    }

   public static function getGroupName($w3,$groupID)
    {
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_groups
                             WHERE groupID = '$groupID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   public static function getGroupID($w3,$userID)
    {
	 // Return the groupID from userID
     $rs = $w3->getDBObj()->query("SELECT groupID FROM ".WM3_cCONFIG_DB_PREFIX."_users
                                   WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0; // No groupID found
     $row = $w3->getDBObj()->fetch($rs);
     return $row->groupID;
    }

   public function setName($name) { $this->name = $name; }
    
   public function getName() { return $this->name; }
   
   public static function getAvatar($w3,$userID)
    {
     $rs = $w3->getDBObj()->query("SELECT avatar FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return WM3_cPATH_DATA."misc_anonymous.png";
     $row = $w3->getDBObj()->fetch($rs);
     return WM3_cPATH_AVATARS.$row->avatar;
    }

   public static function renderUserLogin($w3)
    {
     // Render login panel in home page

     // Create login panel
     $_DATA1 = $_DATA2 = $_DATA3 = $_COLSPAN1 = $_COLSPAN2 = $_COLSPAN3 = array();
     $logged = $w3->getAuthenticateUserID();//TODO farlo piu' sicuro con query che controlla $w3->getAuthenticateUserID()==$row->userID ?
     $show = $w3->getPreferences('show_online_users_visitors');
     $link1 = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER;
     $link2 = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME;
     if(!$logged) // No user logged 
      {
	   $b1 = new wm3GUIButton('send',$w3->getWord(1240));
	   $b2 = new wm3GUIButton('send',$w3->getWord(829));
       $button_login = "<div align=\"center\">".$b1->render()."</div>";
       $button_email = "<div align=\"center\">".$b2->render()."</div>";
       $f1 = new wm3GUITextField('user_login'   ,'','',14);
       $f2 = new wm3GUITextField('user_password','','',14,255,true);
       $f3 = new wm3GUITextField('email'        ,'','',16);
       $_DATA1[0]->label_login    = $w3->getWord(1240); $_DATA1[0]->content = $f1->render();
       $_DATA1[1]->label_password = $w3->getWord(1461); $_DATA1[1]->content = $f2->render();
       $_DATA1[2]->button = $button_login; $_COLSPAN1[2] = array(2);
       $_DATA2[0]->label  = "<br>".$w3->getWord(826); $_COLSPAN2[0] = array(2);
       $_DATA2[1]->label_email    = $w3->getWord(221);  $_DATA2[1]->content = $f3->render();
       $_DATA2[2]->button = $button_email; $_COLSPAN2[2] = array(2);
      }
     else // User logged
      {
       $_DATA1[0]->user_name = $w3->getWord(574)." <b>".wm3User::getUserLogin($w3,$w3->getAuthenticateUserID())."</b>";
       $_DATA1[1]->user_link = "<a href=\"$link1\">".$w3->getWord(575)."</a> ".$w3->getWord(576)." <a href=\"$link1&action=".WM3_cACTION_LOGOUT."\">logout</a>.";
       $_DATA1[2]->messages  = "<img src=\"".WM3_cPATH_DATA."misc_message.png\" width=\"15\" height=\"10\" border=\"0\"> You have <a href=\"$link1&section=".WM3_cSECTION_USER_MESSAGES."\"> 0 ".$w3->getWord(890)."</a>";
      }
	 if($show) // Total visitors/users logged
	  {
       $total_visitors = "<br>".$w3->getWord(811)." ".wm3Session::getOnlineVisitors($w3);
       $visitor_icon   = "<br>".wm3Util::renderImg('misc_visitor.png');
       $total_users    = $w3->getWord(812)." ".wm3Session::getOnlineUsers($w3);
	   $user_icon      = wm3Util::renderImg('misc_user.png');
       $_DATA3[0]->icon = $visitor_icon; $_DATA3[0]->total = $total_visitors;
       $_DATA3[1]->icon = $user_icon;    $_DATA3[1]->total = $total_users;
       if($w3->getAuthenticateAdminUserID()) // Users logged list (showed only if an user or administrator is logged)
        {
         $_DATA3[2]->label = $w3->getWord(813); $_COLSPAN3[2] = array(2);
         $_DATA3[3]->label = wm3User::renderUserOnlineList($w3); $_COLSPAN3[3] = array(2);
        }
	  }

     // Render List
     $list1 = new wm3GUIList($w3,$_DATA1,'',$_COLSPAN1);
     $list1->setRenderCaption(false);
     if($logged) $list1->setUseColors(false);
     $list1->setRenderPagesNavigator(false);
     $list1->setWidths(array(0,100));

     $list2 = new wm3GUIList($w3,$_DATA2,'',$_COLSPAN2);
     $list2->setRenderCaption(false);
     $list2->setRenderPagesNavigator(false);
     $list2->setWidths(array(0,100));

     $list3 = new wm3GUIList($w3,$_DATA3,'',$_COLSPAN3);
     $list3->setRenderCaption(false);
     $list3->setUseColors(false);
     $list3->setRenderPagesNavigator(false);
     $list3->setWidths(array(0,100));

     $form = new wm3GUIForm($w3,$link1,'','wm3_form');
     $str = $form->renderOpen().$list1->render().$form->renderClose();
     if(!$logged)
      {
	   $form1 = new wm3GUIForm($w3,$link2.'&action='.WM3_cACTION_RETRIEVE_PASSWORD,'','wm3_form');
       $str .= $form1->renderOpen().$list2->render().$form1->renderClose();
      }
     if($show) $str .= $list3->render();
     return $str;
    }

   public static function renderUserBirthday($w3)
    {
     // Render birthday panel in home page
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();

     // Do the query and take the total items number
     $ts = time();
     $birth_date = date("-m-d",$ts);
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                        WHERE birth_date LIKE '%$birth_date' AND visible = '".WM3_cENABLED."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."'
                        ORDER BY userID";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link."&userID=$row->userID";
       $age  = date("Y",$ts) - substr($row->birth_date,0,4);
       $cake = wm3Util::renderImg("misc_birthday.png");
       $name = wm3Util::makeLink(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_USER_INFORMATIONS."&userID=$row->userID",$row->login)." ($age ".$w3->getWord(1635).")";
       $_DATA[$p]->icon = $cake;
       $_DATA[$p]->name = $name;
       // Buttons
       //$_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178));
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     if($total_items > 0) $list->setTitle($w3->getWord(1634)."<br><br>");
     $list->setRenderCaption(false);
     $list->setEmptyLabel($w3->getWord(1633));
     $list->setWidths(array(0,100));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function emailExists($w3,$email,$userID = 0)
    {
	 // Check if an email its already in the database
	 if($w3->getAction() == WM3_cACTION_EDIT_USER)
	  {
	   if(!$userID) $userID = $w3->getVariable('userID');
	   $rs = $w3->getDBObj()->query("SELECT email FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '$userID'");
       $row = $w3->getDBObj()->fetch($rs);
  	   if($row) $old_email = $row->email; else $old_email = "";
	   if($old_email == $email) return false;
	  }
     $rs = $w3->getDBObj()->query("SELECT email FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE email = '$email'");
     if($w3->getDBObj()->totalRows($rs) == 0) return false;
	 return true;
	}

   public static function loginExists($w3,$login)
    {
	 // Check if a login its already in the database
     $rs = $w3->getDBObj()->query("SELECT login FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE login = '$login'");
     if($w3->getDBObj()->totalRows($rs) == 0) return false;
	 return true;
	}

   public static function renderRank($w3,$userID)
    {
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                                   WHERE userID = '$userID'");
     $row = $w3->getDBObj()->fetch($rs,false);
	 $value = $row['admin'] + $row['special'];
	 for($i = 1; $i <= 8; $i++) $value += $row['f'.$i];
	 $str = wm3Util::makeStars($w3,$value/2);
	 return $str;
    }

   public static function renderVitality($w3,$userID,$width = 130,$height = 8)
    {//TODO prendere commenti e forum post
     $rs = $w3->getDBObj()->query("SELECT COUNT(*) AS tot_news FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE userID = '$userID'");
     $row = $w3->getDBObj()->fetch($rs);
	 $value = $row->tot_news/2;
	 if($value > 100) $value = 100;
	 $str = wm3Util::makePercentageBar($w3,$value,$width,$height)." ($value%)";
	 return $str;
    }

   public static function renderUserOnlineList($w3)
    {
     // Render online user list
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_sessions WHERE userID != 0");
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
   	   $admin_pic = wm3Util::renderImg('misc_user.png',$w3->getWord(-1).'Standard user');
       if(wm3User::isAdministrator($w3,$row->userID)) $admin_pic = wm3Util::renderImg('misc_admin.png',$w3->getWord(998));
       if(wm3User::isSuperUser($w3,$row->userID))     $admin_pic = wm3Util::renderImg('misc_superuser.png',$w3->getWord(-1).'Superuser');
       $_DATA[$p]->image = $admin_pic;
       $_DATA[$p]->login = wm3Util::makeLink(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_USER_INFORMATIONS."&userID=$row->userID",wm3User::getUserLogin($w3,$row->userID));
	   $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setRenderPagesNavigator(false);
     $list->setRenderCaption(false);
     $list->setWidths(array(0,100));
     $list->setRenderTable(false);
     $list->setColumns(2);
     return $list->renderBody();
    }

   public static function renderRetrievePassword($w3)
    {
	 // Change and retrieve a new password for an user from email (home side)
	 $email  = $w3->getVariable('email','post');
     $userID = wm3User::getUserIDFromEmail($w3,wm3Util::quoteDB($email));
	 $login  = wm3User::getUserLogin($w3,$userID);
     if($userID) {
		          // Send the password by email
				  $password   = wm3Util::generatePassword();
	              $sender     = $w3->getPreferences('service_email');
                  $subject    = "Your new password";
                  $email_body = "<html><head></head><body>Your new password for <a href=\"http://".$w3->getPreferences('site_address')."\">".$w3->getPreferences('site_address')."</a> is <b>$password</b><br><br>Please login and change it soon!</body></html>";
				  $to         = $email;
                  $sended = @mail($to,$subject,$email_body,"From: $sender\nContent-Type: text/html; charset=\"iso-8859-1\"Content-Transfer-Encoding: quoted-printable\"\nX-Mailer: PHP/".phpversion());
				  if($sended) {
					           $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET password = '".md5($password)."' WHERE userID = '".$userID."'");
					           $str = "Password changed for user <b>$login</b>.<br>The new password was send to <b>$email</b>.<br><br>Please login and change this new password soon.";
						      }
				  else        {
					           $str = "Sending email error, email not sendend and password not changed!";
						      }
				 }
	 else        {
		          // Email not found
				  if(!wm3Util::isEmail($email)) $str = $w3->getWord(1151);
				  else                          $str = "<b>$email</b> ".$w3->getWord(828);
				 }
	 return $str;
	}

  }

?>
