<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 // Define starting time used for page generator time
 define('WM3_cSTART_TIME', wm3Util::microtimeFloat());

 // Initial php settings
 ini_set('magic_quotes_runtime', 0);
 ini_set('magic_quotes_sybase',  0);

 // Define all constants
 define('WM3_cVERSION',    '3.1.1');
 define('WM3_cDB_VERSION', '3.1');

 // Website languages constants
 define('WM3_cLANGUAGE_ALL', 0);
 define('WM3_cLANGUAGE_EN',  1);
 define('WM3_cLANGUAGE_IT',  2);
 define('WM3_cLANGUAGE_FR',  3);
 define('WM3_cLANGUAGE_DE',  4);
 define('WM3_cLANGUAGE_ES',  5);
 define('WM3_cLANGUAGE_NL',  6);
 define('WM3_cLANGUAGE_EL',  7);

 // Website stage constants
 define('WM3_cSTAGE_HOME',            0);
 define('WM3_cSTAGE_USER',            1);
 define('WM3_cSTAGE_ADMIN',           2);
 define('WM3_cSTAGE_CHAT',            3);
 define('WM3_cSTAGE_RSS',             4);
 define('WM3_cSTAGE_BANNER_EXCHANGE', 5);
 define('WM3_cSTAGE_CAPTCHA',         6);
 define('WM3_cSTAGE_KERNEL',          7);

 // Website section constants
 define('WM3_cSECTION_HOME',          0);
 define('WM3_cSECTION_FAQ',           1);
 define('WM3_cSECTION_SEARCH_ENGINE', 2);
 define('WM3_cSECTION_MARKET',        3);
 define('WM3_cSECTION_BANNERS',       4);
 define('WM3_cSECTION_NEWS',          5);
 define('WM3_cSECTION_LINKS',         6);
 define('WM3_cSECTION_NEWSLETTER',    7);
 define('WM3_cSECTION_HOROSCOPE',     8);
 define('WM3_cSECTION_MESSAGES',      9);
 define('WM3_cSECTION_MENUS',         10);
 define('WM3_cSECTION_PANELS',        11);
 define('WM3_cSECTION_CHANNELS',      12);
 define('WM3_cSECTION_USERS',         13);
 define('WM3_cSECTION_PAGES',         14);
 define('WM3_cSECTION_ECOMMERCE',     15);
 define('WM3_cSECTION_SURVEYS',       16);
 define('WM3_cSECTION_FORUMS',        17);
 define('WM3_cSECTION_DOWNLOADS',     18);
 define('WM3_cSECTION_DIRECTORIES',   19);
 define('WM3_cSECTION_MEDIA_ALBUMS',  20);
 define('WM3_cSECTION_PREFERENCES',   21);
 define('WM3_cSECTION_METATAGS',      22);
 define('WM3_cSECTION_FOLDERS',       23);
 define('WM3_cSECTION_WEBMAIL',       24);
 define('WM3_cSECTION_STATISTICS',    25);
 define('WM3_cSECTION_LANGUAGES',     26);

 define('WM3_cSECTION_DATABASE',      99);

 define('WM3_cSECTION_USER_MESSAGES',         100);
 define('WM3_cSECTION_USER_INFORMATIONS',     101);
 define('WM3_cSECTION_WEBMATIC_INFORMATIONS', 102);

 define('WM3_cSECTION_NEED_CONFIG_SYSTEM', 200);
 define('WM3_cSECTION_NEED_CONFIG_FILE',   201);
 define('WM3_cSECTION_NEED_DATABASE',      202);
 define('WM3_cSECTION_NEED_UPDATE',        203);
 define('WM3_cSECTION_NEED_USER',          204);
 
 // Website session constants
 define('WM3_cSESSION_HIT',   1);
 define('WM3_cSESSION_RATE',  2);
 define('WM3_cSESSION_VOTE',  3);
 define('WM3_cSESSION_CLICK', 4);
 
 // Website action constants
 define('WM3_cACTION_CHANGE_LANGUAGE',                               1);
 define('WM3_cACTION_SEARCH',                                        2);
 define('WM3_cACTION_SHOW_SINGLE_FAQ',                               3);
 define('WM3_cACTION_SHOW_SINGLE_DOWNLOAD',                          4);
 define('WM3_cACTION_GET_FILE_DOWNLOAD',                             5);
 define('WM3_cACTION_SHOW_SINGLE_NEWS',                              6);
 define('WM3_cACTION_PRINTABLE_SINGLE_NEWS',                         7);
 define('WM3_cACTION_NEWSLETTER',                                    8);
 define('WM3_cACTION_DELETE_NEWS_COMMENT',                          10);
 define('WM3_cACTION_DELETE_ALL_NEWS_COMMENT',                      11);
 define('WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT',                12);
 define('WM3_cACTION_PRINTABLE_SINGLE_ECOMMERCE_PRODUCT',           13);
 define('WM3_cACTION_INFORMATIONS_SINGLE_ECOMMERCE_PRODUCT',        14);
 define('WM3_cACTION_SEND_INFORMATIONS_SINGLE_ECOMMERCE_PRODUCT',   15);
 define('WM3_cACTION_SEND_TO_FRIEND_SINGLE_ECOMMERCE_PRODUCT',      16);
 define('WM3_cACTION_SEND_SEND_TO_FRIEND_SINGLE_ECOMMERCE_PRODUCT', 17);
 define('WM3_cACTION_SHOW_FORUM_DISCUSSIONS',                       18);
 define('WM3_cACTION_SHOW_FORUM_REPLIES',                           19);
 define('WM3_cACTION_ADD_FORUM_DISCUSSION',                         20);
 define('WM3_cACTION_ADD_FORUM_REPLY',                              22);
 define('WM3_cACTION_ADD_FORUM_QUOTE',                              24);
 define('WM3_cACTION_EDIT_FORUM_DISCUSSION',                        26);
 define('WM3_cACTION_LOCK_FORUM_DISCUSSION',                        28);
 define('WM3_cACTION_UNLOCK_FORUM_DISCUSSION',                      29);
 define('WM3_cACTION_DELETE_FORUM_DISCUSSION',                      30);
 define('WM3_cACTION_EDIT_FORUM_REPLY',                             31);
 define('WM3_cACTION_DELETE_FORUM_REPLY',                           33);
 define('WM3_cACTION_SEARCH_FORUM',                                 34); 
 define('WM3_cACTION_ADD_GUESTBOOK_MESSAGE',                        36);
 define('WM3_cACTION_DELETE_GUESTBOOK_MESSAGE',                     38);
 define('WM3_cACTION_DELETE_ALL_GUESTBOOK_MESSAGE',                 39);
 define('WM3_cACTION_SURVEY_VOTE',                                  40);
 define('WM3_cACTION_SURVEY_RESULTS',                               41);
 define('WM3_cACTION_NEWSLETTER_JOIN',                              42);
 define('WM3_cACTION_SHOW_SINGLE_MEDIA',                            43);
 define('WM3_cACTION_RATE_MEDIA_ALBUM_ITEM',                        44);
 define('WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING',             45);
 define('WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED',            46);
 define('WM3_cACTION_SEND_TO_FRIEND',                               47);
 define('WM3_cACTION_CONTACT',                                      48);
 define('WM3_cACTION_SHOW_SINGLE_ANNOUNCEMENT',                     49);
 define('WM3_cACTION_RATE_DIRECTORY_ITEM',                          50);
 define('WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING',               51);
 define('WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM',                   52);
 define('WM3_cACTION_CONSULT_HOROSCOPE',                            53);
 define('WM3_cACTION_RETRIEVE_PASSWORD',                            54);
 define('WM3_cACTION_SHOW_USER_INFORMATIONS',                       55);
 define('WM3_cACTION_SHOW_ECOMMERCE_CART',                          56);
 define('WM3_cACTION_PROCESS_ECOMMERCE_ORDER',                      57);
 define('WM3_cACTION_CONFIRM_ECOMMERCE_ORDER',                      58); 
 //define('WM3_cACTION_PAY_ECOMMERCE_ORDER',                          59);
 define('WM3_cACTION_ADD_ECOMMERCE_CART_ITEM',                      60); 
 define('WM3_cACTION_DELETE_ECOMMERCE_CART_ITEM',                   61);
 define('WM3_cACTION_SEND_CHATROOM_SENTENCE',                       62);
 define('WM3_cACTION_JOIN_CHATROOM',                                63);
 define('WM3_cACTION_SHOW_CHATROOM_USER',                           64);
 define('WM3_cACTION_SHOW_CHATROOM_SENTENCE',                       65);
 define('WM3_cACTION_SHOW_RSS_CATEGORY',                            66);
 define('WM3_cACTION_SHOW_RSS_AUTHOR',                              67);
 define('WM3_cACTION_CLICK_BANNER_EXCHANGE',                        68);
 define('WM3_cACTION_LOGIN_WEBMAIL_SERVER',                         69);
 define('WM3_cACTION_LOGOUT_WEBMAIL_SERVER',                        70);
 define('WM3_cACTION_WRITE_WEBMAIL_SERVER_EMAIL',                   71);
 define('WM3_cACTION_UPLOAD_ATTACH_WEBMAIL_SERVER_EMAIL',           72);
 define('WM3_cACTION_GET_ATTACH_WEBMAIL_SERVER_EMAIL',              73);
 define('WM3_cACTION_DELETE_ATTACH_WEBMAIL_SERVER_EMAIL',           74);
 define('WM3_cACTION_DELETE_ATTACH_ALL_WEBMAIL_SERVER_EMAIL',       75);
 define('WM3_cACTION_REPLY_WEBMAIL_SERVER_EMAIL',                   76);
 define('WM3_cACTION_SEND_WEBMAIL_SERVER_EMAIL',                    77);
 define('WM3_cACTION_DELETE_WEBMAIL_SERVER_EMAIL',                  78);
 define('WM3_cACTION_DELETE_MULTI_WEBMAIL_SERVER_EMAIL',            79);
 define('WM3_cACTION_READ_WEBMAIL_SERVER_EMAIL',                    80);
 define('WM3_cACTION_SAVE_ATTACH_WEBMAIL_SERVER_EMAIL',             81);
 define('WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING',                     82);

 define('WM3_cACTION_LOGIN',                                    200);
 define('WM3_cACTION_LOGOUT',                                   201);
 define('WM3_cACTION_DISABLE_PANEL',                            202);
 define('WM3_cACTION_ENABLE_PANEL',                             203);
 define('WM3_cACTION_DELETE_PANEL',                             204);
 define('WM3_cACTION_ADD_PANEL',                                205);
 define('WM3_cACTION_EDIT_PANEL',                               206);
 define('WM3_cACTION_SWAP_PANEL',                               207);
 define('WM3_cACTION_DISABLE_PAGE',                             208);
 define('WM3_cACTION_ENABLE_PAGE',                              209);
 define('WM3_cACTION_DELETE_PAGE',                              210);
 define('WM3_cACTION_ADD_PAGE',                                 211);
 define('WM3_cACTION_EDIT_PAGE',                                212);
 define('WM3_cACTION_DUPLICATE_PAGE',                           213);
 define('WM3_cACTION_DISABLE_MENU_ITEM',                        214);
 define('WM3_cACTION_ENABLE_MENU_ITEM',                         215);
 define('WM3_cACTION_DELETE_MENU_ITEM',                         216);
 define('WM3_cACTION_ADD_MENU_ITEM',                            217);
 define('WM3_cACTION_EDIT_MENU_ITEM',                           218);
 define('WM3_cACTION_SWAP_MENU_ITEM',                           219);
 define('WM3_cACTION_UNLINK_MENU_ITEM',                         220);
 define('WM3_cACTION_DISABLE_MENU',                             221);
 define('WM3_cACTION_ENABLE_MENU',                              222);
 define('WM3_cACTION_DELETE_MENU',                              223);
 define('WM3_cACTION_ADD_MENU',                                 224);
 define('WM3_cACTION_EDIT_MENU',                                225);
 define('WM3_cACTION_SHOW_MENU',                                226);
 define('WM3_cACTION_DISABLE_USER',                             227);
 define('WM3_cACTION_ENABLE_USER',                              228);
 define('WM3_cACTION_DELETE_USER',                              229);
 define('WM3_cACTION_ADD_USER',                                 230);
 define('WM3_cACTION_EDIT_USER',                                231);
 define('WM3_cACTION_EDIT_PASSWORD_USER',                       233);
 define('WM3_cACTION_DISABLE_GROUP',                            235);
 define('WM3_cACTION_ENABLE_GROUP',                             236);
 define('WM3_cACTION_DELETE_GROUP',                             237);
 define('WM3_cACTION_ADD_GROUP',                                238);
 define('WM3_cACTION_EDIT_GROUP',                               240);
 define('WM3_cACTION_SHOW_GROUP',                               242);
 define('WM3_cACTION_DISABLE_MESSAGE',                          243);
 define('WM3_cACTION_ENABLE_MESSAGE',                           244);
 define('WM3_cACTION_DELETE_MESSAGE',                           245);
 define('WM3_cACTION_ADD_MESSAGE',                              246);
 define('WM3_cACTION_EDIT_MESSAGE',                             248);
 define('WM3_cACTION_DUPLICATE_MESSAGE',                        250);
 define('WM3_cACTION_DISABLE_HOROSCOPE',                        251);
 define('WM3_cACTION_ENABLE_HOROSCOPE',                         252);
 define('WM3_cACTION_DELETE_HOROSCOPE',                         253);
 define('WM3_cACTION_ADD_HOROSCOPE',                            254);
 define('WM3_cACTION_EDIT_HOROSCOPE',                           256);
 define('WM3_cACTION_DUPLICATE_HOROSCOPE',                      258);
 define('WM3_cACTION_DISABLE_QUOTE',                            259);
 define('WM3_cACTION_ENABLE_QUOTE',                             260);
 define('WM3_cACTION_DELETE_QUOTE',                             261);
 define('WM3_cACTION_ADD_QUOTE',                                262);
 define('WM3_cACTION_EDIT_QUOTE',                               264);
 define('WM3_cACTION_DUPLICATE_QUOTE',                          266);
 define('WM3_cACTION_SHOW_QUOTE',                               267);
 define('WM3_cACTION_DISABLE_NEWS_CATEGORY',                    268);
 define('WM3_cACTION_ENABLE_NEWS_CATEGORY',                     269);
 define('WM3_cACTION_DELETE_NEWS_CATEGORY',                     270);
 define('WM3_cACTION_ADD_NEWS_CATEGORY',                        271);
 define('WM3_cACTION_EDIT_NEWS_CATEGORY',                       273);
 define('WM3_cACTION_SHOW_NEWS',                                275);
 define('WM3_cACTION_DISABLE_NEWS',                             276);
 define('WM3_cACTION_ENABLE_NEWS',                              277);
 define('WM3_cACTION_DELETE_NEWS',                              278);
 define('WM3_cACTION_ADD_NEWS',                                 279);
 define('WM3_cACTION_EDIT_NEWS',                                281);
 define('WM3_cACTION_DUPLICATE_NEWS',                           283);
 define('WM3_cACTION_SHOW_NEWSLETTER_ITEM',                     284);
 define('WM3_cACTION_DISABLE_NEWSLETTER_ITEM',                  285);
 define('WM3_cACTION_ENABLE_NEWSLETTER_ITEM',                   286);
 define('WM3_cACTION_DELETE_NEWSLETTER_ITEM',                   287);
 define('WM3_cACTION_ADD_NEWSLETTER_ITEM',                      288);
 define('WM3_cACTION_EDIT_NEWSLETTER_ITEM',                     290);
 define('WM3_cACTION_SHOW_NEWSLETTER',                          292);
 define('WM3_cACTION_WRITE_NEWSLETTER',                         293);
 define('WM3_cACTION_SEND_NEWSLETTER',                          294);
 define('WM3_cACTION_RESEND_NEWSLETTER',                        295);
 define('WM3_cACTION_DELETE_NEWSLETTER',                        296);
 define('WM3_cACTION_DISABLE_FAQ_CATEGORY',                     297);
 define('WM3_cACTION_ENABLE_FAQ_CATEGORY',                      298);
 define('WM3_cACTION_DELETE_FAQ_CATEGORY',                      299);
 define('WM3_cACTION_ADD_FAQ_CATEGORY',                         300);
 define('WM3_cACTION_EDIT_FAQ_CATEGORY',                        302);
 define('WM3_cACTION_SHOW_FAQ',                                 304);
 define('WM3_cACTION_DISABLE_FAQ',                              305);
 define('WM3_cACTION_ENABLE_FAQ',                               306);
 define('WM3_cACTION_DELETE_FAQ',                               307);
 define('WM3_cACTION_ADD_FAQ',                                  308);
 define('WM3_cACTION_EDIT_FAQ',                                 310);
 define('WM3_cACTION_DISABLE_LINK_CATEGORY',                    312);
 define('WM3_cACTION_ENABLE_LINK_CATEGORY',                     313);
 define('WM3_cACTION_DELETE_LINK_CATEGORY',                     314);
 define('WM3_cACTION_ADD_LINK_CATEGORY',                        315);
 define('WM3_cACTION_EDIT_LINK_CATEGORY',                       317);
 define('WM3_cACTION_SHOW_LINK',                                319);
 define('WM3_cACTION_DISABLE_LINK',                             320);
 define('WM3_cACTION_ENABLE_LINK',                              321);
 define('WM3_cACTION_DELETE_LINK',                              322);
 define('WM3_cACTION_ADD_LINK',                                 323);
 define('WM3_cACTION_EDIT_LINK',                                325);
 define('WM3_cACTION_DISABLE_SEARCH_ENGINE_ITEM',               327);
 define('WM3_cACTION_ENABLE_SEARCH_ENGINE_ITEM',                328);
 define('WM3_cACTION_DELETE_SEARCH_ENGINE_ITEM',                329);
 define('WM3_cACTION_ADD_SEARCH_ENGINE_ITEM',                   330);
 define('WM3_cACTION_EDIT_SEARCH_ENGINE_ITEM',                  332);
 define('WM3_cACTION_DISABLE_ECOMMERCE_CATEGORY',               334);
 define('WM3_cACTION_ENABLE_ECOMMERCE_CATEGORY',                335);
 define('WM3_cACTION_DELETE_ECOMMERCE_CATEGORY',                336);
 define('WM3_cACTION_ADD_ECOMMERCE_CATEGORY',                   337); 
 define('WM3_cACTION_EDIT_ECOMMERCE_CATEGORY',                  339);
 define('WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY',               341);
 define('WM3_cACTION_DISABLE_ECOMMERCE_SUBCATEGORY',            342);
 define('WM3_cACTION_ENABLE_ECOMMERCE_SUBCATEGORY',             343);
 define('WM3_cACTION_DELETE_ECOMMERCE_SUBCATEGORY',             344);
 define('WM3_cACTION_ADD_ECOMMERCE_SUBCATEGORY',                345);
 define('WM3_cACTION_EDIT_ECOMMERCE_SUBCATEGORY',               347);
 define('WM3_cACTION_SHOW_ECOMMERCE_PRODUCT',                   349);
 define('WM3_cACTION_SHOW_ECOMMERCE_SPECIAL_OFFER',             350);
 define('WM3_cACTION_DISABLE_ECOMMERCE_PRODUCT',                351);
 define('WM3_cACTION_ENABLE_ECOMMERCE_PRODUCT',                 352);
 define('WM3_cACTION_DELETE_ECOMMERCE_PRODUCT',                 353);
 define('WM3_cACTION_ADD_ECOMMERCE_PRODUCT',                    354);
 define('WM3_cACTION_EDIT_ECOMMERCE_PRODUCT',                   356);
 define('WM3_cACTION_SHOW_ECOMMERCE_PICTURE',                   358);
 define('WM3_cACTION_DISABLE_ECOMMERCE_PICTURE',                359);
 define('WM3_cACTION_ENABLE_ECOMMERCE_PICTURE',                 360);
 define('WM3_cACTION_DELETE_ECOMMERCE_PICTURE',                 361);
 define('WM3_cACTION_ADD_ECOMMERCE_PICTURE',                    362);
 define('WM3_cACTION_SAVE_ECOMMERCE_PICTURE',                   363);
 define('WM3_cACTION_EDIT_ECOMMERCE_PICTURE',                   364);
 define('WM3_cACTION_SHOW_ECOMMERCE_ORDER',                     366);
 define('WM3_cACTION_SHOW_ECOMMERCE_ORDER_ITEM',                367);
 define('WM3_cACTION_REJECT_ECOMMERCE_ORDER',                   368);
 define('WM3_cACTION_ACCEPT_ECOMMERCE_ORDER',                   369);
 define('WM3_cACTION_SEND_ECOMMERCE_ORDER',                     370);
 define('WM3_cACTION_WAIT_ECOMMERCE_ORDER',                     371);
 define('WM3_cACTION_DELETE_ECOMMERCE_ORDER',                   372);
 define('WM3_cACTION_PRINTABLE_ECOMMERCE_ORDER',                373);
 define('WM3_cACTION_DISABLE_SURVEY',                           374);
 define('WM3_cACTION_ENABLE_SURVEY',                            375);
 define('WM3_cACTION_DELETE_SURVEY',                            376);
 define('WM3_cACTION_ADD_SURVEY',                               377);
 define('WM3_cACTION_EDIT_SURVEY',                              379);
 define('WM3_cACTION_RESET_SURVEY',                             381);
 define('WM3_cACTION_DISABLE_SURVEY_ITEM',                      382);
 define('WM3_cACTION_ENABLE_SURVEY_ITEM',                       383);
 define('WM3_cACTION_DELETE_SURVEY_ITEM',                       384);
 define('WM3_cACTION_ADD_SURVEY_ITEM',                          385);
 define('WM3_cACTION_EDIT_SURVEY_ITEM',                         387);
 define('WM3_cACTION_RESET_SURVEY_ITEM',                        389);
 define('WM3_cACTION_SHOW_SURVEY_ITEM',                         390);
 define('WM3_cACTION_DISABLE_WEBMAIL_SERVER',                   392);
 define('WM3_cACTION_ENABLE_WEBMAIL_SERVER',                    393);
 define('WM3_cACTION_DELETE_WEBMAIL_SERVER',                    394);
 define('WM3_cACTION_ADD_WEBMAIL_SERVER',                       395);
 define('WM3_cACTION_EDIT_WEBMAIL_SERVER',                      397);
 define('WM3_cACTION_DISABLE_CHANNEL_CATEGORY',                 399);
 define('WM3_cACTION_ENABLE_CHANNEL_CATEGORY',                  400);
 define('WM3_cACTION_DELETE_CHANNEL_CATEGORY',                  401);
 define('WM3_cACTION_ADD_CHANNEL_CATEGORY',                     402);
 define('WM3_cACTION_EDIT_CHANNEL_CATEGORY',                    404);
 define('WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY',                 406);
 define('WM3_cACTION_DISABLE_CHANNEL_SUBCATEGORY',              407);
 define('WM3_cACTION_ENABLE_CHANNEL_SUBCATEGORY',               408);
 define('WM3_cACTION_DELETE_CHANNEL_SUBCATEGORY',               409);
 define('WM3_cACTION_ADD_CHANNEL_SUBCATEGORY',                  410);
 define('WM3_cACTION_EDIT_CHANNEL_SUBCATEGORY',                 412);
 define('WM3_cACTION_SHOW_CHANNEL_BLOCK',                       414);
 define('WM3_cACTION_DISABLE_CHANNEL_BLOCK',                    415); 
 define('WM3_cACTION_ENABLE_CHANNEL_BLOCK',                     416); 
 define('WM3_cACTION_DELETE_CHANNEL_BLOCK',                     417);   
 define('WM3_cACTION_ADD_CHANNEL_BLOCK',                        418);
 define('WM3_cACTION_EDIT_CHANNEL_BLOCK',                       420);
 define('WM3_cACTION_DISABLE_MARKET_CATEGORY',                  422);
 define('WM3_cACTION_ENABLE_MARKET_CATEGORY',                   423);
 define('WM3_cACTION_DELETE_MARKET_CATEGORY',                   424);
 define('WM3_cACTION_ADD_MARKET_CATEGORY',                      425);
 define('WM3_cACTION_EDIT_MARKET_CATEGORY',                     427);
 define('WM3_cACTION_SHOW_MARKET_SUBCATEGORY',                  429);
 define('WM3_cACTION_DISABLE_MARKET_SUBCATEGORY',               430); 
 define('WM3_cACTION_ENABLE_MARKET_SUBCATEGORY',                431); 
 define('WM3_cACTION_DELETE_MARKET_SUBCATEGORY',                432);   
 define('WM3_cACTION_ADD_MARKET_SUBCATEGORY',                   433);
 define('WM3_cACTION_EDIT_MARKET_SUBCATEGORY',                  435);
 define('WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT',                 437);
 define('WM3_cACTION_DISABLE_MARKET_ANNOUNCEMENT',              438);
 define('WM3_cACTION_ENABLE_MARKET_ANNOUNCEMENT',               439);
 define('WM3_cACTION_DELETE_MARKET_ANNOUNCEMENT',               440);
 define('WM3_cACTION_ADD_MARKET_ANNOUNCEMENT',                  441);
 define('WM3_cACTION_EDIT_MARKET_ANNOUNCEMENT',                 443);
 define('WM3_cACTION_DISABLE_DOWNLOAD_CATEGORY',                445);
 define('WM3_cACTION_ENABLE_DOWNLOAD_CATEGORY',                 446);
 define('WM3_cACTION_DELETE_DOWNLOAD_CATEGORY',                 447);
 define('WM3_cACTION_ADD_DOWNLOAD_CATEGORY',                    448);
 define('WM3_cACTION_EDIT_DOWNLOAD_CATEGORY',                   450);
 define('WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY',                452);
 define('WM3_cACTION_DISABLE_DOWNLOAD_SUBCATEGORY',             453);
 define('WM3_cACTION_ENABLE_DOWNLOAD_SUBCATEGORY',              454);
 define('WM3_cACTION_DELETE_DOWNLOAD_SUBCATEGORY',              455);
 define('WM3_cACTION_ADD_DOWNLOAD_SUBCATEGORY',                 456);
 define('WM3_cACTION_EDIT_DOWNLOAD_SUBCATEGORY',                458);
 define('WM3_cACTION_DISABLE_DOWNLOAD',                         460);
 define('WM3_cACTION_ENABLE_DOWNLOAD',                          461);
 define('WM3_cACTION_DELETE_DOWNLOAD',                          462);
 define('WM3_cACTION_ADD_DOWNLOAD',                             463);
 define('WM3_cACTION_SAVE_DOWNLOAD',                            464);
 define('WM3_cACTION_EDIT_DOWNLOAD',                            465);
 define('WM3_cACTION_UPDATE_DOWNLOAD',                          466);
 define('WM3_cACTION_DUPLICATE_DOWNLOAD',                       467);
 define('WM3_cACTION_SHOW_DOWNLOAD',                            468);
 define('WM3_cACTION_DISABLE_FORUM_CATEGORY',                   469);
 define('WM3_cACTION_ENABLE_FORUM_CATEGORY',                    470);
 define('WM3_cACTION_DELETE_FORUM_CATEGORY',                    471);
 define('WM3_cACTION_ADD_FORUM_CATEGORY',                       472);
 define('WM3_cACTION_EDIT_FORUM_CATEGORY',                      474);
 define('WM3_cACTION_SHOW_FORUM',                               476);
 define('WM3_cACTION_DISABLE_FORUM',                            477);
 define('WM3_cACTION_ENABLE_FORUM',                             478);
 define('WM3_cACTION_DELETE_FORUM',                             479);
 define('WM3_cACTION_ADD_FORUM',                                480);
 define('WM3_cACTION_EDIT_FORUM',                               482);
 define('WM3_cACTION_SHOW_CHATROOM',                            484);
 define('WM3_cACTION_DISABLE_CHATROOM',                         485);
 define('WM3_cACTION_ENABLE_CHATROOM',                          486);
 define('WM3_cACTION_DELETE_CHATROOM',                          487);
 define('WM3_cACTION_ADD_CHATROOM',                             488);
 define('WM3_cACTION_EDIT_CHATROOM',                            490);
 define('WM3_cACTION_DISABLE_MEDIA_ALBUM_CATEGORY',             492);
 define('WM3_cACTION_ENABLE_MEDIA_ALBUM_CATEGORY',              493);
 define('WM3_cACTION_DELETE_MEDIA_ALBUM_CATEGORY',              494);
 define('WM3_cACTION_ADD_MEDIA_ALBUM_CATEGORY',                 495);
 define('WM3_cACTION_EDIT_MEDIA_ALBUM_CATEGORY',                497);
 define('WM3_cACTION_SHOW_MEDIA_ALBUM',                         499);
 define('WM3_cACTION_DISABLE_MEDIA_ALBUM',                      500);
 define('WM3_cACTION_ENABLE_MEDIA_ALBUM',                       501);
 define('WM3_cACTION_DELETE_MEDIA_ALBUM',                       502);
 define('WM3_cACTION_ADD_MEDIA_ALBUM',                          503);
 define('WM3_cACTION_EDIT_MEDIA_ALBUM',                         505);
 define('WM3_cACTION_MOVE_MEDIA_ALBUM',                         507);
 define('WM3_cACTION_MOVE_MEDIA_ALBUM_ITEM',                    508);
 define('WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM',                    509);
 define('WM3_cACTION_DISABLE_MEDIA_ALBUM_ITEM',                 510);
 define('WM3_cACTION_ENABLE_MEDIA_ALBUM_ITEM',                  511);
 define('WM3_cACTION_DELETE_MEDIA_ALBUM_ITEM',                  512);
 define('WM3_cACTION_ADD_MEDIA_ALBUM_ITEM',                     513);
 define('WM3_cACTION_SAVE_MEDIA_ALBUM_ITEM',                    514);
 define('WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM',                    515);
 define('WM3_cACTION_UPDATE_MEDIA_ALBUM_ITEM',                  516);
 define('WM3_cACTION_DUPLICATE_MEDIA_ALBUM_ITEM',               517);
 define('WM3_cACTION_DELETE_FILE_FOLDER',                       518);
 define('WM3_cACTION_ADD_FILE_FOLDER',                          519);
 define('WM3_cACTION_UPLOAD_FILE_FOLDER',                       520);
 define('WM3_cACTION_SHOW_FILE_TEMP_FOLDER',                    521);
 define('WM3_cACTION_DELETE_FILE_TEMP_FOLDER',                  522);
 define('WM3_cACTION_EMPTY_FILE_TEMP_FOLDER',                   523);
 define('WM3_cACTION_DISABLE_BANNER',                           524);
 define('WM3_cACTION_ENABLE_BANNER',                            525);
 define('WM3_cACTION_DELETE_BANNER',                            526);
 define('WM3_cACTION_ADD_BANNER',                               527);
 define('WM3_cACTION_EDIT_BANNER',                              529);
 define('WM3_cACTION_ACTIVATE_BANNER',                          531);
 define('WM3_cACTION_DEACTIVATE_BANNER',                        532);
 define('WM3_cACTION_DUPLICATE_BANNER',                         533);
 define('WM3_cACTION_SHOW_BANNER_EXCHANGE',                     534);
 define('WM3_cACTION_DISABLE_BANNER_EXCHANGE',                  535);
 define('WM3_cACTION_ENABLE_BANNER_EXCHANGE',                   536);
 define('WM3_cACTION_DELETE_BANNER_EXCHANGE',                   537);
 define('WM3_cACTION_ADD_BANNER_EXCHANGE',                      538);
 define('WM3_cACTION_SAVE_BANNER_EXCHANGE',                     539);
 define('WM3_cACTION_EDIT_BANNER_EXCHANGE',                     540);
 define('WM3_cACTION_UPDATE_BANNER_EXCHANGE',                   541);
 define('WM3_cACTION_ACTIVATE_BANNER_EXCHANGE',                 542);
 define('WM3_cACTION_CODE_BANNER_EXCHANGE',                     543);
 define('WM3_cACTION_STATISTICS_BANNER_EXCHANGE',               544);
 define('WM3_cACTION_SHOW_BANNER_EXCHANGE_CREDIT',              545);
 define('WM3_cACTION_UPDATE_BANNER_EXCHANGE_CREDIT',            546);
 define('WM3_cACTION_ENABLE_BANNER_EXCHANGE_UNLIMITED_CREDIT',  547);
 define('WM3_cACTION_DISABLE_BANNER_EXCHANGE_UNLIMITED_CREDIT', 548);
 define('WM3_cACTION_SHOW_DIRECTORY',                           549);//???
 define('WM3_cACTION_DISABLE_DIRECTORY',                        550);//???
 define('WM3_cACTION_ENABLE_DIRECTORY',                         551);//???
 define('WM3_cACTION_DELETE_DIRECTORY',                         552);
 define('WM3_cACTION_ADD_DIRECTORY',                            553);
 define('WM3_cACTION_EDIT_DIRECTORY',                           555);
 define('WM3_cACTION_SHOW_DIRECTORY_ITEM',                      557);
 define('WM3_cACTION_DISABLE_DIRECTORY_ITEM',                   558);
 define('WM3_cACTION_ENABLE_DIRECTORY_ITEM',                    559);
 define('WM3_cACTION_DELETE_DIRECTORY_ITEM',                    560);
 define('WM3_cACTION_ADD_DIRECTORY_ITEM',                       561);
 define('WM3_cACTION_EDIT_DIRECTORY_ITEM',                      563);
 define('WM3_cACTION_DUPLICATE_DIRECTORY_ITEM',                 565);
 define('WM3_cACTION_SET_NOT_READ_USER_MESSAGE',                566);
 define('WM3_cACTION_SHOW_USER_MESSAGE',                        567);
 define('WM3_cACTION_DELETE_USER_MESSAGE',                      568);
 define('WM3_cACTION_ADD_USER_MESSAGE',                         569);
 define('WM3_cACTION_REPLY_USER_MESSAGE',                       571);
 define('WM3_cACTION_DUPLICATE_USER_MESSAGE',                   573);//???
 define('WM3_cACTION_EDIT_ASPECT_PREFERENCES',                  575);
 define('WM3_cACTION_EDIT_CONTENT_PREFERENCES',                 577);
 define('WM3_cACTION_EDIT_ECOMMERCE_PREFERENCES',               579);
 define('WM3_cACTION_EDIT_BANNER_EXCHANGE_PREFERENCES',         581);
 define('WM3_cACTION_CHANGE_LANGUAGE_CONTENT_PREFERENCES',      583);
 define('WM3_cACTION_SHOW_ECOMMERCE_FIELD_PREFERENCES',         584);
 define('WM3_cACTION_DISABLE_ECOMMERCE_FIELD_PREFERENCES',      585);
 define('WM3_cACTION_ENABLE_ECOMMERCE_FIELD_PREFERENCES',       586);
 define('WM3_cACTION_DELETE_ECOMMERCE_FIELD_PREFERENCES',       587);
 define('WM3_cACTION_ADD_ECOMMERCE_FIELD_PREFERENCES',          588);
 define('WM3_cACTION_EDIT_ECOMMERCE_FIELD_PREFERENCES',         590);
 define('WM3_cACTION_SHOW_HISTORY_STATISTIC',                   592);
 define('WM3_cACTION_SHOW_TREND_STATISTIC',                     593);
 define('WM3_cACTION_RENDER_TREND_STATISTIC',                   594);//TODO è inutile? fare il tutto solo con WM3_cACTION_SHOW_TREND_STATISTIC
 define('WM3_cACTION_RESET_ALL_STATISTIC',                      595);
 define('WM3_cACTION_SHOW_LOG',                                 596);
 define('WM3_cACTION_DELETE_LOG',                               597);
 define('WM3_cACTION_DELETE_ALL_LOG',                           598);
 define('WM3_cACTION_SET_TOTAL_VISITORS',                       599);
 define('WM3_cACTION_SET_TOTAL_SIGNALATIONS',                   600);
 define('WM3_cACTION_SHOW_PHP_INFORMATIONS',                    601);
 define('WM3_cACTION_DISABLE_LANGUAGE',                         602);
 define('WM3_cACTION_ENABLE_LANGUAGE',                          603);
 define('WM3_cACTION_RESTORE_DATABASE',                         604);
 define('WM3_cACTION_LOAD_RESTORE_DATABASE',                    605);//TODO
 define('WM3_cACTION_SAVE_BACKUP_DATABASE',                     606);
 define('WM3_cACTION_DELETE_DATABASE',                          607);

 define('WM3_cACTION_SETUP_NEXT',            700);
 define('WM3_cACTION_SETUP_SAVEDB',          701);
 define('WM3_cACTION_SETUP_SAVEUSER',        702);
 define('WM3_cACTION_SETUP_CHANGE_LANGUAGE', 703);

 // Page constants                                   
 define('WM3_cPAGE_CATEGORY_MARKET',              1);
 define('WM3_cPAGE_CATEGORY_FAQ',                 2);
 define('WM3_cPAGE_CATEGORY_SEARCH_ENGINE',       3);
 define('WM3_cPAGE_CATEGORY_USER_REGISTRATION',   4);
 define('WM3_cPAGE_CATEGORY_LINKS',               5);
 define('WM3_cPAGE_CATEGORY_STATISTICS',          6);
 define('WM3_cPAGE_CATEGORY_USER_INFORMATIONS',   7);
 define('WM3_cPAGE_CATEGORY_FORUMS',              8);
 define('WM3_cPAGE_CATEGORY_DOWNLOADS',           9);
 define('WM3_cPAGE_CATEGORY_GUESTBOOKS',         10);
 define('WM3_cPAGE_CATEGORY_DIRECTORIES',        11);
 define('WM3_cPAGE_CATEGORY_MEDIA_ALBUMS',       12);
 define('WM3_cPAGE_CATEGORY_CONTACT',            13);
 define('WM3_cPAGE_CATEGORY_CHAT',               14);
 define('WM3_cPAGE_CATEGORY_WEBMAIL',            15);
 define('WM3_cPAGE_CATEGORY_CUSTOM',             16);
 define('WM3_cPAGE_CATEGORY_EXPANSION',          17);

 define('WM3_cPAGE_TYPE_CHANNELS', 1);
 define('WM3_cPAGE_TYPE_NORMAL',   2);

 define('WM3_cVISIBILITY_ALL',   1);
 define('WM3_cVISIBILITY_USERS', 2);
 define('WM3_cVISIBILITY_GROUP', 3);

 // Panel constants
 define('WM3_cPANEL_CATEGORY_MESSAGES',       1);
 define('WM3_cPANEL_CATEGORY_LOGIN',          2);
 define('WM3_cPANEL_CATEGORY_CHANNELS',       3);
 define('WM3_cPANEL_CATEGORY_SEARCH',         4);
 define('WM3_cPANEL_CATEGORY_HOROSCOPE',      5);
 define('WM3_cPANEL_CATEGORY_NEWSLETTER',     6);
 define('WM3_cPANEL_CATEGORY_SEND_TO_FRIEND', 7);
 define('WM3_cPANEL_CATEGORY_LANGUAGES',      8);
 define('WM3_cPANEL_CATEGORY_ECOMMERCE',      9);
 define('WM3_cPANEL_CATEGORY_SURVEY',        10);
 define('WM3_cPANEL_CATEGORY_FORTUNE',       11);
 define('WM3_cPANEL_CATEGORY_RSS_FEEDS',     12);
 define('WM3_cPANEL_CATEGORY_BIRTHDAY',      13);
 define('WM3_cPANEL_CATEGORY_SPECIAL_OFFER', 14);
 define('WM3_cPANEL_CATEGORY_CUSTOM',        15);
 define('WM3_cPANEL_CATEGORY_EXPANSION',     16);
 define('WM3_cPANEL_CATEGORY_MENU',          17);
 define('WM3_cPANEL_CATEGORY_TAGS',          18);

 define('WM3_cPANEL_LEFT',   1);
 define('WM3_cPANEL_CENTER', 2);
 define('WM3_cPANEL_RIGHT',  3);

 // Constants for the skin
 define('WM3_cSKIN_RENDER_LEFT',   WM3_cPANEL_LEFT);
 define('WM3_cSKIN_RENDER_CENTER', WM3_cPANEL_CENTER);
 define('WM3_cSKIN_RENDER_RIGHT',  WM3_cPANEL_RIGHT);
 define('WM3_cSKIN_RENDER_NEWS',   4);
 define('WM3_cSKIN_RENDER_PAGE',   5);

 define('WM3_cSKIN_LAYOUT_FLUID', 0);
 define('WM3_cSKIN_LAYOUT_FIXED', 1);

 define('WM3_cSKIN_NO_ERROR', 0);
 define('WM3_cSKIN_ERROR',    2);

 // Menu item constants
 define('WM3_cMENU_ITEM_CATEGORY_CHANNEL',  1);
 define('WM3_cMENU_ITEM_CATEGORY_HOME',     2);
 define('WM3_cMENU_ITEM_CATEGORY_ADMIN',    3);
 define('WM3_cMENU_ITEM_CATEGORY_USER',     4);
 define('WM3_cMENU_ITEM_CATEGORY_EXTERNAL', 5);
 define('WM3_cMENU_ITEM_CATEGORY_CUSTOM',   6);
 define('WM3_cMENU_ITEM_CATEGORY_VOID',     7);

 // Contents render mode
 define('WM3_cRENDER_MODE_PLAIN_TEXT',   1);
 define('WM3_cRENDER_MODE_HTML',         2);
 define('WM3_cRENDER_MODE_BB_CODE',      3);
 define('WM3_cRENDER_MODE_HTML_BB_CODE', 4);

 // Expansion constants
 define('WM3_cEXPANSION_SECTION_MIN', 1000);
 define('WM3_cEXPANSION_TYPE_ADMIN',  'admin');
 define('WM3_cEXPANSION_TYPE_USER',   'user');
 define('WM3_cEXPANSION_TYPE_PAGE',   'page');
 define('WM3_cEXPANSION_TYPE_PANEL',  'panel');

 // Form validation constants
 define('WM3_cVALIDATE_NOT_NULL',                          1);
 define('WM3_cVALIDATE_EMAIL',                             2);
 define('WM3_cVALIDATE_EXISTS_EMAIL',                      3);
 define('WM3_cVALIDATE_IS_URL',                            4);
 define('WM3_cVALIDATE_IS_URL_ABSOLUTE',                   5);
 define('WM3_cVALIDATE_IS_URL_RELATIVE',                   6);
 define('WM3_cVALIDATE_IS_INTEGER',                        7);
 define('WM3_cVALIDATE_IS_ALPHANUMERIC',                   8);
 define('WM3_cVALIDATE_IS_DATE',                           9);
 define('WM3_cVALIDATE_IS_LOGIN',                         10);
 define('WM3_cVALIDATE_EXISTS_LOGIN',                     11);
 define('WM3_cVALIDATE_EXISTS_CATEGORY',                  12);
 define('WM3_cVALIDATE_EXISTS_SUBCATEGORY',               13);
 define('WM3_cVALIDATE_EXISTS_SURVEY',                    14);
 define('WM3_cVALIDATE_EXISTS_FORUM',                     15);
 define('WM3_cVALIDATE_EXISTS_FORUM_DISCUSSION',          16);
 define('WM3_cVALIDATE_EXISTS_FORUM_DISCUSSION_OR_REPLY', 17);
 define('WM3_cVALIDATE_EXISTS_DIRECTORY',                 18);
 define('WM3_cVALIDATE_EXISTS_URL',                       19);
 define('WM3_cVALIDATE_EXISTS_PAGE',                      20);
 define('WM3_cVALIDATE_EXISTS_EXPANSION_PAGE',            21);
 define('WM3_cVALIDATE_EXISTS_EXPANSION_PANEL',           22);
 define('WM3_cVALIDATE_EXISTS_MENU_ITEM_PAGE',            23);
 define('WM3_cVALIDATE_EXISTS_MENU_ITEM_SUBCHANNEL',      24);
 define('WM3_cVALIDATE_EXISTS_PANEL_SURVEY',              25);
 define('WM3_cVALIDATE_EXISTS_PANEL_MENU',                26); 
 define('WM3_cVALIDATE_DIRECTORY_HOME_IS_URL',            27);
 define('WM3_cVALIDATE_DIRECTORY_DOWNLOAD_IS_URL',        28);
 define('WM3_cVALIDATE_HOME_DIRECTORY_DOWNLOAD_IS_URL',   29);
 define('WM3_cVALIDATE_MENU_ITEM_EXTERNAL_NOT_NULL',      30);
 define('WM3_cVALIDATE_FIELDS_EQUAL',                     31);
 define('WM3_cVALIDATE_GREATER_EQUAL_THAN',               32);
 define('WM3_cVALIDATE_LESS_EQUAL_THAN',                  33);
 define('WM3_cVALIDATE_IS_FORUM_DISCUSSION',              34);
 define('WM3_cVALIDATE_USER_PASSWORD_MATCH',              35);
 define('WM3_cVALIDATE_CAPTCHA',                          36);
 define('WM3_cVALIDATE_EXISTS_MENU',                      37);

 // Kernel action constants
 define('WM3_cACTION_KERNEL_RENDER_SELECT_IMAGES',              1);
 define('WM3_cACTION_KERNEL_GET_DOWNLOAD',                      2);
 define('WM3_cACTION_KERNEL_RENDER_PAGE_EDITOR',                3);
 define('WM3_cACTION_KERNEL_RENDER_PAGE_EDITOR_TINYMCE',        4);
 define('WM3_cACTION_KERNEL_RENDER_NEWS_EDITOR',                5);
 define('WM3_cACTION_KERNEL_RENDER_NEWS_EDITOR_TINYMCE',        6);
 define('WM3_cACTION_KERNEL_RENDER_NEWSLETTER_EDITOR',          7);
 define('WM3_cACTION_KERNEL_RENDER_NEWSLETTER_EDITOR_TINYMCE',  8);
 define('WM3_cACTION_KERNEL_TINYMCE_JS_IMAGE_LIST',             9);
 define('WM3_cACTION_KERNEL_TINYMCE_JS_LINK_LIST',             10);
 define('WM3_cACTION_KERNEL_JS_CONSTANTS',                     11);
 define('WM3_cACTION_KERNEL_UPLOAD_FILE',                      12);
 define('WM3_cACTION_KERNEL_HTACCESS',                         13);

 // Regular expressions (used also in javascript)
 define('WM3_cRE_URL',                "/^(https?:\/\/){1}(([0-9a-zA-Z_!~*'().&=+$%-]+: )?[0-9a-zA-Z_!~*'().&=+$%-]+@)?(([0-9]{1,3}\.){3}[0-9]{1,3}|([0-9a-zA-Z_!~*'()-]+\.)*([0-9a-zA-Z][0-9a-zA-Z-]{0,61})?[0-9a-zA-Z]\.[a-zA-Z]{2,6})(:[0-9]{1,4})?((\/?)|(\/[0-9a-zA-Z_!~*'().;?:@&=+$,%#-]+)+\/?)$/");
 define('WM3_cRE_URL_RELATIVE',       "/^(((\/{1}\.{1})?[a-zA-Z0-9_!~*'().;?:@&=+$,%#-]+\/?)+(\.{1}[a-zA-Z0-9]{2,4})?)$/");
 define('WM3_cRE_IMAGE_URL',          "/^(https?\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(?:\/\S*)?(?:[a-zA-Z0-9_])+(.[jJ][pP][gG]|.[jJ][pP][eE][gG]|.[gG][iI][fF]|.[pP][nN][gG]))$/");
 define('WM3_cRE_IMAGE_URL_RELATIVE', "/^(((\.\.){1}\/)*|(\/){1})?(([a-zA-Z0-9]*)\/)*([a-zA-Z0-9]*)+(.[jJ][pP][gG]|.[jJ][pP][eE][gG]|.[gG][iI][fF]|.[pP][nN][gG])+$/");

 // Other constants
 define('WM3_cUSER_ANONYMOUS', 0);

 define('WM3_cMAIN_MENU', 1);

 define('WM3_cMENU_ID_PREFIX', 'wm3_menu');

 define('WM3_cSTATISTIC_YEARLY',        0);
 define('WM3_cSTATISTIC_MONTHLY',       1);
 define('WM3_cSTATISTIC_DAILY',         2);
 define('WM3_cSTATISTIC_HOURLY',        3);
 define('WM3_cSTATISTIC_WEEKLY',        4);
 define('WM3_cSTATISTIC_HOURLY_GLOBAL', 5);
 define('WM3_cSTATISTIC_TREND_STEP_HOUR', 1);
 define('WM3_cSTATISTIC_TREND_STEP_DAY',  2);

 define('WM3_cOS_OTHER',    1);
 define('WM3_cOS_WINDOWS',  2);
 define('WM3_cOS_LINUX',    3);
 define('WM3_cOS_MACOS',    4);
 define('WM3_cOS_SUNOS',    5);
 define('WM3_cOS_BEOS',     6);
 define('WM3_cOS_AMIGAOS',  7);
 define('WM3_cOS_AIX',      8);
 define('WM3_cOS_FREEBSD',  9);
 define('WM3_cOS_IRIX',    10);
 define('WM3_cOS_OS2',     11);

 define('WM3_cBROWSER_OTHER',         1);
 define('WM3_cBROWSER_SEARCH_ENGINE', 2);
 define('WM3_cBROWSER_IE',            3);
 define('WM3_cBROWSER_MOZILLA',       4);
 define('WM3_cBROWSER_CHROME',        5);
 define('WM3_cBROWSER_NETSCAPE',      6);
 define('WM3_cBROWSER_OPERA',         7);
 define('WM3_cBROWSER_KONQUEROR',     8);
 define('WM3_cBROWSER_IBROWSE',       9);
 define('WM3_cBROWSER_LYNX',          10);
 define('WM3_cBROWSER_WEBTV',         11);

 define('WM3_cSURVEY_TARGET_ALL',     1);
 define('WM3_cSURVEY_TARGET_USERS',   2);
 define('WM3_cSURVEY_RESULT_PUBLIC',  1);
 define('WM3_cSURVEY_RESULT_PRIVATE', 2);
 define('WM3_cSURVEY_LAYOUT_COMBO',   1);
 define('WM3_cSURVEY_LAYOUT_MENU',    2);

 define('WM3_cCHATROOM_VISIBILITY_PUBLIC',  1);
 define('WM3_cCHATROOM_VISIBILITY_PRIVATE', 2);

 define('WM3_cECOMMERCE_AVAILABILITY_HEIGHT',  1);
 define('WM3_cECOMMERCE_AVAILABILITY_EVERAGE', 2);
 define('WM3_cECOMMERCE_AVAILABILITY_LOW',     3);
 define('WM3_cECOMMERCE_AVAILABILITY_NONE',    4);
 define('WM3_cECOMMERCE_ORDER_WAITING', 1);
 define('WM3_cECOMMERCE_ORDER_ACCEPT',  2);
 define('WM3_cECOMMERCE_ORDER_SENDED',  3);
 define('WM3_cECOMMERCE_ORDER_REJECT',  4);

 define('WM3_cNEWSLETTER_TARGET_MEMBERS',  1);
 define('WM3_cNEWSLETTER_TARGET_USERS',    2);
 define('WM3_cNEWSLETTER_ACTION_SEND',     1);
 define('WM3_cNEWSLETTER_ACTION_SIMULATE', 2);
 define('WM3_cNEWSLETTER_FORMAT_TEXT',     1);
 define('WM3_cNEWSLETTER_FORMAT_HTML',     2);

 define('WM3_cMEDIA_ALBUM_TYPE_ALL',            1);
 define('WM3_cMEDIA_ALBUM_TYPE_PICTURES',       2);
 define('WM3_cMEDIA_ALBUM_TYPE_VIDEO',          3);
 define('WM3_cMEDIA_ALBUM_TYPE_AUDIO',          4);
 define('WM3_cMEDIA_ALBUM_TYPE_PICTURES_VIDEO', 5);
 define('WM3_cMEDIA_ALBUM_TYPE_PICTURES_AUDIO', 6);
 define('WM3_cMEDIA_ALBUM_TYPE_AUDIO_VIDEO',    7);

 define('WM3_cMARKET_ANNOUNCEMENT_TYPE_SELL', 1);
 define('WM3_cMARKET_ANNOUNCEMENT_TYPE_BUY',  2);

 define('WM3_cWEBMAIL_SERVER_VISIBILITY_ALL',   1);
 define('WM3_cWEBMAIL_SERVER_VISIBILITY_USERS', 2);
 define('WM3_cWEBMAIL_SERVER_VISIBILITY_GROUP', 3);
 define('WM3_cWEBMAIL_SERVER_AUTHENTICATION_TYPE_SERVER',    1);
 define('WM3_cWEBMAIL_SERVER_AUTHENTICATION_TYPE_SPECIFIED', 2);
 define('WM3_cWEBMAIL_SERVER_AUTHENTICATION_TYPE_NONE',      3);
 define('WM3_cWEBMAIL_SERVER_PROTOCOL_POP3',     1);
 define('WM3_cWEBMAIL_SERVER_PROTOCOL_POP3_SSL', 2);

 define('WM3_cPREFERENCES_FOOT_ALL',          1);
 define('WM3_cPREFERENCES_FOOT_COUNTER_DATE', 2);
 define('WM3_cPREFERENCES_FOOT_COUNTER_TIME', 3);
 define('WM3_cPREFERENCES_FOOT_DATE_TIME',    4);
 define('WM3_cPREFERENCES_FOOT_COUNTER',      5);
 define('WM3_cPREFERENCES_FOOT_DATE',         6);
 define('WM3_cPREFERENCES_FOOT_TIME',         7);
 define('WM3_cPREFERENCES_FOOT_NONE',         8);

 define('WM3_cPREFERENCES_REGISTRATION_FULL',   1);
 define('WM3_cPREFERENCES_REGISTRATION_NORMAL', 2);
 define('WM3_cPREFERENCES_REGISTRATION_FAST',   3);

 define('WM3_cPREFERENCES_ECOMMERCE_CATALOGUE_ONLY', 1);
 define('WM3_cPREFERENCES_ECOMMERCE_FULL',           2);
 define('WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_INTEGER', 1);
 define('WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_DECIMAL', 2);
 define('WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_STRING',  3);
 define('WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_CATALOGUE',    1);
 define('WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_TRANSACTIONS', 2);
 define('WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_BOTH',         3);

 define('WM3_cFOLDER_ALL',         0);
 define('WM3_cFOLDER_IMG',         1);
 define('WM3_cFOLDER_ECOMMERCE',   2);
 define('WM3_cFOLDER_MEDIA_ALBUM', 3);
 define('WM3_cFOLDER_DOWNLOADS',   4);
 
 define('WM3_cUPLOAD_FROM_LOCAL',  0);
 define('WM3_cUPLOAD_FROM_REMOTE', 1);
 define('WM3_cUPLOAD_FROM_URL',    2);

 define('WM3_cCHANNEL_BLOCK_TYPE_PAGE',       0);
 define('WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL', 1);

 define('WM3_cFILE_INTERNAL', 0);
 define('WM3_cFILE_EXTERNAL', 1); 

 define('WM3_cDIRECTORY_FILE',    1);
 define('WM3_cDIRECTORY_NO_FILE', 2);
 
 define('WM3_cQUOTE_DB', 1);
 define('WM3_cYES', 1);
 define('WM3_cNO',  0);
 define('WM3_cENABLED',  1);
 define('WM3_cDISABLED', 0);
 define('WM3_cUSER_ALL',           1);
 define('WM3_cUSER_GENDER_MALE',   2);
 define('WM3_cUSER_GENDER_FEMALE', 3);
 define('WM3_cUSER_SPECIAL',       4);
 define('WM3_cNO_IMAGE',     0);
 define('WM3_cALIGN_LEFT',   1);
 define('WM3_cALIGN_CENTER', 2);
 define('WM3_cALIGN_RIGHT',  3);

 define('WM3_cDATABASE_TARGET_FILE',  1);
 define('WM3_cDATABASE_TARGET_VIDEO', 2);

 define('WM3_cSETUP_OFF',   0);
 define('WM3_cSETUP_ON',    1);
 define('WM3_cWARNING_OFF', 0);
 define('WM3_cWARNING_ON',  1);
 define('WM3_cDEBUG_OFF',   0);
 define('WM3_cDEBUG_ON',    1);
 
 // Common functions

 function __autoload($class_name)
  {
   // Redefine __autoload function to autoload the classes
   global $WM3_cCLASSES_LOADED;

   $WM3_cCLASSES_LOADED .= "$class_name<br>";
   if(file_exists(WM3_cPATH_CLASSES.$class_name.'.php'))
    require_once(WM3_cPATH_CLASSES.$class_name.'.php');
   if(file_exists(WM3_cPATH_CLASSES.'GUI/'.$class_name.'.php'))
    require_once(WM3_cPATH_CLASSES.'GUI/'.$class_name.'.php');
   if(file_exists(WM3_cPATH_CLASSES.'DB/'.$class_name.'.php'))
    require_once(WM3_cPATH_CLASSES.'DB/'.$class_name.'.php');
  }

 function stripslashes_deep($value)
  {
   // Strip slashes from a string (callback recursively function)
   $value = is_array($value) ? array_map('stripslashes_deep', $value) : stripslashes($value);
   return $value;
  }

?>
