<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com


//echo "ho incluso _postgresql.h";
//$connection = pg_connect("host=localhost user=postgres password=admin dbname=wip3");//php_pgsql.dll
//echo $connection;
//print_r ( pg_query($connection,"INSERT INTO webmatic_countries VALUES (0, 'ad', 'Andorra', '0')" ) );
//INSERT INTO webmatic_countries(code,name,hits) VALUES ('kk', 'Andorra', '0');//Non mettere il campo con auto increment ( modificare quindi la classe wm3DBInsertInto )
//print_r ( pg_query($connection,"CREATE TABLE test ( bannerID integer primary key, title char(255), banner_type integer, enabled integer, languageID integer, ts integer )") );
//$result = dbms_query("SELECT * FROM information_schema.tables WHERE table_name = 'webmatic_database'",$connection);
//if(dbms_num_rows($result) == 0) echo "false";
//else                            echo "true";
//die;


 defined('WM3_cEXEC') or die('Denied');

 function dbms_connect($server,$user,$password)
  {
   return pg_connect("host=localhost user=postgres password=admin dbname=wip3");
   //return @pg_connect("host=$server user=$user password=$password");
  }

 function dbms_select_db($name,$connection)
  {
   //host=sheep port=5432 dbname=mary user=lamb password=foo
   //return @pg_connect("host=$server user=$user password=$password");
   return pg_connect("host=localhost user=postgres password=admin dbname=wip3");
   //return @mysql_select_db($name,$connection);
  }

 function dbms_parse_select($query)
  {//TODO
   $q = '';
   $_SELECT = $query->getSelect();
   $_FROM   = $query->getFrom();
   $_WHERE  = $query->getWhere();

   // Select
   $q .= 'SELECT '.$_SELECT.' ';

   // From
   if(is_array($_FROM))
    {
     $q .= 'FROM ';
	 for($i = 0; $i < count($_FROM); $i++)
      {
       $q .= WM3_cCONFIG_DB_PREFIX.$_FROM[$i];
       if($i != count($_FROM) - 1) $q .= ', '; else $q .= ' ';
	  }
    }
   else $q .= 'FROM '.WM3_cCONFIG_DB_PREFIX.$_FROM.' ';

   // Where
   if(is_array($_WHERE))
    {
     $q .= 'WHERE ';
	 /*foreach($_FROM as $value)//TODO
       {
        $q .= WM3_cCONFIG_DB_PREFIX.$value.', ';
	   }*/
    }
   else $q .= 'WHERE '.$_WHERE;

   return $q;
  }

 function dbms_parse_create_table($query,$charset = '')
  {//TODO
   $q = $e = '';
   $_FIELDS = $query->getFields();
   $name    = $query->getName();

   // Create table
   $q .= 'CREATE TABLE '.WM3_cCONFIG_DB_PREFIX.$name.' ( ';
   for($i = 0; $i < count($_FIELDS); $i++) // Parse fields
    {
	 $f = $_FIELDS[$i];
     switch($f->getType())
      {
       case WM3_cDB_INT:
        {
		 $q .= $f->getName();
 		 if($f->isAutoIncrement()) $q .= ' SERIAL';
 		 else                      $q .= ' INT';
		 //if($f->getUnsigned()) $q .= ' UNSIGNED';
		 break;
		}
       case WM3_cDB_BIGINT:
        {
		 $q .= $f->getName();
 		 if($f->isAutoIncrement()) $q .= ' BIGSERIAL';
 		 else                      $q .= ' BIGINT';
		 //if($f->getUnsigned()) $q .= ' UNSIGNED';
		 break;
		}
       case WM3_cDB_FLOAT:
        {
		 $q .= $f->getName().' REAL'; // TODO REAL(M,D)...???
		 break;
		}
       case WM3_cDB_DOUBLE:
        {
		 $q .= $f->getName().' DOUBLE PRECISION'; // TODO DOUBLE PRECISION(M,D)...???
		 break;
		}
       case WM3_cDB_CHAR:
        {
		 $q .= $f->getName().' CHAR('.$f->getLenght().')';
		 break;
		}
       case WM3_cDB_TEXT:
        {
		 $q .= $f->getName().' TEXT';
		 break;
		}
       case WM3_cDB_DATE:
        {
		 $q .= $f->getName().' DATE';
		 break;
		}
	  }
	 // Field flags
	 if($f->isPrimaryKey())    $q .= ' PRIMARY KEY';
	 //TODOif($f->isKey())           $e .= ', KEY '.$f->getName().' ('.$f->getName().')';//usare isIndex() al posto di isKey() per definire un indice ???
	 if($f->isUnique())        $q .= ' UNIQUE';
	 if($f->isUniqueKey())     $q .= ' UNIQUE KEY';
     if($f->isNotNull())       $q .= ' NOT NULL';
	 if($i != count($_FIELDS) - 1) $q .= ', ';
    }
   $q .= $e.' ) ';

   // Specify table charset
   //if($charset) $q .= 'CHARACTER SET '.$charset; // TODO vedere come creare una tabella con un certo charset in postgresql...

   return $q;
  }

 function dbms_parse_insert_into($query)
  {//TODO
   $q = $f = '';
   $_FIELDS = $query->getFields();
   $_VALUES = $query->getValues();
   $name    = $query->getName();

   // Insert Into
   if(is_array($_FIELDS))
    {
     for($i = 0; $i < count($_FIELDS); $i++) // Parse fields
      {
       if($i == 0) $f .= ' (';
       $f .= $_FIELDS[$i];
       if($i != count($_FIELDS) - 1) $f .= ', ';
       if($i == count($_FIELDS) - 1) $f .= ') ';
      }
    }
   $q .= 'INSERT INTO '.WM3_cCONFIG_DB_PREFIX.$name.' '.$f.' VALUES (';
   for($i = 0; $i < count($_VALUES); $i++) // Parse values
    {
	 if(is_array($_VALUES[$i]))
	  {
	   if($i != 0) $q .= ' (';
	   for($j = 0; $j < count($_VALUES[$i]); $j++)
	    {
	     //$v = $_VALUES[$i][$j];
	     $v = wm3Util::quoteDB($_VALUES[$i][$j]);//TODO controllare... (farlo per tutti i tipi di query???)
	     $q .= "'$v'";
	     if($j != count($_VALUES[$i]) - 1) $q .= ', ';
	    }
	   if($i != count($_VALUES) - 1) $q .= '),';
      }
     else
      {
	   //$v = $_VALUES[$i];
	   $v = wm3Util::quoteDB($_VALUES[$i]); //TODO controllare... (farlo per tutti i tipi di query???)
	   $q .= "'$v'";
	   if($i != count($_VALUES) - 1) $q .= ', ';
      }
    }
   $q .= ') ';

   return $q;
  }

 function dbms_parse_alter_database($query)
  {
   //TODO fare funzionante...  
   //$q = "ALTER DATABASE ".$query->getName().' '.$query->getParameter();
   return 'SELECT 1+1';//$q; // Dummy query
  }

 function dbms_parse_query($query,$charset)
  {
   switch($query->getStatement())
    {
     case WM3_cDB_SELECT:         return dbms_parse_select($query);
     case WM3_cDB_CREATE_TABLE:   return dbms_parse_create_table($query,$charset);
     case WM3_cDB_INSERT_INTO:    return dbms_parse_insert_into($query);
     case WM3_cDB_ALTER_DATABASE: return dbms_parse_alter_database($query);
    }
  }

 function dbms_query($query,$connection)
  {
   return pg_query($connection,$query);
  }

 function dbms_fetch_object($result)
  {
   return pg_fetch_object($result);
  }

 function dbms_fetch_array($result)
  {
   return pg_fetch_array($result);
  }

 function dbms_num_rows($result)
  {
   return pg_num_rows($result);
  }

 function dbms_close($connection)
  {
   return @pg_close($connection);
  }

 function dbms_list_tables($name,$connection)
  {
   return @mysql_list_tables($name,$connection);
  }

 function dbms_tablename($result,$i)
  {
   return mysql_tablename($result,$i);
  }

 function dbms_list_fields($name,$table,$connection)
  {
   return @mysql_list_fields($name,$table,$connection);
  }

 function dbms_num_fields($result)
  {
   return mysql_num_fields($result);
  }

 function dbms_field_name($result,$i)
  {
   return @mysql_field_name($result,$i);
  }

 function dbms_field_type($result,$i)
  {
   return @mysql_field_type($result,$i);
  }

 function dbms_field_len($result,$i)
  {
   return @mysql_field_len($result,$i);
  }

 function dbms_field_flags($result,$i)
  {
   return @mysql_field_flags($result,$i);
  }

 function dbms_get_server_info($connection)
  {
   $_VERSION = @pg_version($connection);
   return $_VERSION['client'];//$_VERSION['server'];//TODO
  }

 function dbms_exists_table($table,$connection)
  {
   $result = dbms_query("SELECT * FROM information_schema.tables WHERE table_name = '$table'",$connection);
   if(dbms_num_rows($result) == 0) return false;
   else                            return true;
  }

 function dbms_use_charset($charset,$connection)
  {
   dbms_query("SET NAMES '$charset'",$connection);//TODO verificare questa query
  }

?>
