<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3GUIDate extends wm3GUIField
  {
   // Arrays

   // Variables
   private $value_day,$value_month,$value_year;
   private $name_day,$name_month,$name_year;
   private $languageID;

   function __construct($name,$value,$label,$languageID)
    {
	 $this->languageID = $languageID;
	 $this->name_day   = $name."_day";
	 $this->name_month = $name."_month";
	 $this->name_year  = $name."_year";
	 parent::__construct($name,'',$label);
 	 $this->setDate($value);
    }

   public function render()
    {
	 // Render date field
     $this->value = wm3Util::quoteHTML($this->value);
     if(!$this->id)
      {
       $day   = "<input type=\"text\" name=\"$this->name_day\"   value=\"$this->value_day\"   size=\"3\" maxlength=\"2\" $this->javascript $this->inactive>";
       $month = "<input type=\"text\" name=\"$this->name_month\" value=\"$this->value_month\" size=\"3\" maxlength=\"2\" $this->javascript $this->inactive>";
       $year  = "<input type=\"text\" name=\"$this->name_year\"  value=\"$this->value_year\"  size=\"5\" maxlength=\"4\" $this->javascript $this->inactive>";
      }
//     else {$str = "<input id=\"$this->id\" type=\"text\" name=\"$this->name\" value=\"$this->value\" size=\"$this->size\" maxlength=\"$this->maxlenght\" $this->javascript $this->inactive>";}
     if($this->languageID == WM3_cLANGUAGE_EN) $str = $year." / ".$month." / ".$day;
     else                                      $str = $day." / ".$month." / ".$year;
     return $this->extra_content_before.$str.$this->extra_content_after;     
	}

   public function setDate($date)
    {
     // Set date from date YYYY-MM-DD date format
     if($date == '0000-00-00')
      $this->value_year = $this->value_month = $this->value_day = $this->value = '';
     else {
           $this->value_year  = substr($date,0,4);
           $this->value_month = substr($date,5,2);
           $this->value_day   = substr($date,8,2);
           $this->value = $date;
          }
	}

   public function setDateYMD($year,$month,$day)
    {
     // Set date from separate YYYY,MM and DD
     $this->value_year  = $year;
     $this->value_month = $month;
     $this->value_day   = $day;
     if($year.$month.$day == '') $this->value = '';
     else                        $this->value = $year.'-'.$month.'-'.$day;
	}

  }

?>
