<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');
 
 // Constant to evaluate for the skin creation
 define('WM3_cSKIN_VERSION', 'echo WM3_cVERSION;');

 define('WM3_cSKIN_BROWSER_BAR_TITLE',       'echo $this->getPreferencesContents(\'browser_bar_title\');');
 define('WM3_cSKIN_SITE_TITLE',              'echo $this->getPreferencesContents(\'title\');');
 define('WM3_cSKIN_CSS_FILE',                'echo $this->_skin->getCSS($this);');
 define('WM3_cSKIN_INCLUDE_JAVASCRIPT',      'echo $this->includeJavaScript();');
 define('WM3_cSKIN_METATAGS',                'echo $this->_skin->makeMetatags($this);');
 define('WM3_cSKIN_LOGO',                    'echo $this->_skin->makeLogo($this);');
 define('WM3_cSKIN_MENUBAR',                 'echo $this->_skin->makeMenuBar($this);');
 define('WM3_cSKIN_CHANNELSMENU',            'echo $this->_skin->makeChannelsMenu($this);');
 define('WM3_cSKIN_FOOT',                    'echo $this->getPreferencesContents(\'foot\');');
 define('WM3_cSKIN_FOOT_INFORMATIONS',       'echo $this->_skin->renderFootInformations($this);');
 define('WM3_cSKIN_FOOT_ADMIN_INFORMATIONS', 'echo $this->_skin->renderFootAdminInformations($this);');

 define('WM3_cSKIN_BODY_LEFT',              '$this->_skin->getLeftContent($this);');
 define('WM3_cSKIN_BODY_CENTER',            '$this->_skin->getCenterContent($this);');
 define('WM3_cSKIN_BODY_RIGHT',             '$this->_skin->getRightContent($this);');
 define('WM3_cSKIN_BODY_LEFT_WIDTH',        'echo $this->_skin->getLeftWidth();');
 define('WM3_cSKIN_BODY_LEFT_EXTRA_WIDTH',  'echo $this->_skin->getLeftExtraWidth();');
 define('WM3_cSKIN_BODY_LEFT_CENTER_WIDTH', 'echo $this->_skin->getCenterWidth();');
 define('WM3_cSKIN_BODY_RIGHT_EXTRA_WIDTH', 'echo $this->_skin->getRightExtraWidth();');
 define('WM3_cSKIN_BODY_RIGHT_WIDTH',       'echo $this->_skin->getRightWidth();');

 define('WM3_cSKIN_BANNER_BIG',         'echo $this->_skin->makeBanner($this,1);');
 define('WM3_cSKIN_BANNER_LITTLE',      'echo $this->_skin->makeBanner($this,2);');
 define('WM3_cSKIN_BANNER_RIGHT_UP',    'echo $this->_skin->makeBanner($this,3);');
 define('WM3_cSKIN_BANNER_RIGHT_DOWN1', 'echo $this->_skin->makeBanner($this,4);');
 define('WM3_cSKIN_BANNER_RIGHT_DOWN2', 'echo $this->_skin->makeBanner($this,5);');
 define('WM3_cSKIN_BANNER_CENTER_DOWN', 'echo $this->_skin->makeBanner($this,6);');
 define('WM3_cSKIN_BANNER_LEFT_UP',     'echo $this->_skin->makeBanner($this,7);');
 define('WM3_cSKIN_BANNER_LEFT_DOWN1',  'echo $this->_skin->makeBanner($this,8);');
 define('WM3_cSKIN_BANNER_LEFT_DOWN2',  'echo $this->_skin->makeBanner($this,9);');

 define('WM3_cSKIN_BANNER_EXCHANGE_HOMEPAGE_CONTENT', 'echo "document.write(\'$content\');";');

 define('WM3_cSKIN_TITLE',         'echo $title;');
 define('WM3_cSKIN_SUBTITLE',      'echo $subtitle;'); 
 define('WM3_cSKIN_CONTENT',       'echo $content;');
 define('WM3_cSKIN_BOTTOM',        'echo $bottom;');
 define('WM3_cSKIN_ICON',          'echo $icon;');
 define('WM3_cSKIN_PICTURE',       'echo $picture;');
 define('WM3_cSKIN_LABEL',         'echo $label;');
 define('WM3_cSKIN_INFO',          'echo $info;');
 define('WM3_cSKIN_HITS',          'echo $hits;');
 define('WM3_cSKIN_COLSPAN',       'echo $colspan;');
 define('WM3_cSKIN_WIDTH',         'echo $width;');
 define('WM3_cSKIN_HEIGHT',        'echo $height;');
 define('WM3_cSKIN_WIDTH_LEFT',    'echo $width_left;');
 define('WM3_cSKIN_WIDTH_RIGHT',   'echo $width_right;');
 define('WM3_cSKIN_HEIGHT_TOP',    'echo $height_top;');
 define('WM3_cSKIN_HEIGHT_BOTTOM', 'echo $height_bottom;');
 define('WM3_cSKIN_ID',            'echo $id;');
 define('WM3_cSKIN_EXTRA',         'echo $extra;');
 define('WM3_cSKIN_MENU_ITEM',     'echo $menu_item;');
 define('WM3_cSKIN_COMMENTS',      'echo $comments;');
 define('WM3_cSKIN_COMMENTS_FORM', 'echo $comments_form;');
 define('WM3_cSKIN_QUOTE_OPEN',    'echo $quote_open;');
 define('WM3_cSKIN_QUOTE_CLOSE',   'echo $quote_close;');

 define('WM3_cSKIN_SOCIAL_FACEBOOK', 'echo $social_facebook;');
 define('WM3_cSKIN_SOCIAL_GPLUSONE', 'echo $social_gplusone;');
 define('WM3_cSKIN_SOCIAL_TWITTER',  'echo $social_twitter;');

 define('WM3_cSKIN_PICTURE_CONTENT',      'echo $picture_content;');
 define('WM3_cSKIN_TITLE_CONTENT',        'echo $title_content;');
 define('WM3_cSKIN_DESCRIPTION_CONTENT',  'echo $description_content;');
 define('WM3_cSKIN_PRICE_CONTENT',        'echo $price_content;');
 define('WM3_cSKIN_AVAILABILITY_CONTENT', 'echo $availability_content;');

 define('WM3_cSKIN_MENU',    '$w3->getSkinObj()->makeMenu($w3);');
 define('WM3_cSKIN_SUBMENU', '$w3->getSkinObj()->makeSubMenu($w3,$submenu);');


 define('WM3_cSKIN_SETUP_CSS_FILE', 'echo $setup_css;');
 define('WM3_cSKIN_SETUP_MENU',     'wm3Setup::renderSetupLanguageMenu($w3,$skin);');

 class wm3Skin
  {
   // Skin variables
   private $parent;
   private $name;
   private $css,$php,$js;
   private $layout_type;
   private $left_width,$center_width,$right_width,$left_extra_width,$right_extra_width;
   private $logo,$logo_width,$logo_height,$logo_printable;
   private $left_page_title,$right_page_title;
   private $current_skin_render;

   // Skin arrays
   private $_HEAD,$_BODY,$_FOOT;
   private $_MENU,$_SUBMENU;
   private $_NEWS;
   private $_PANEL;
   private $_FORM,$_LIST;
   private $_SEPARATOR,$_QUOTE,$_MISC;
   private $_BANNERS;
   private $_STARS;
   private $_FORUM_ICON;

   function __construct($parent,$name,$_LOGO,$_BANNERS)
    {
	 // Assign the parent class
	 $this->parent = $parent;

     // Skin name
	 if(!file_exists(WM3_cPATH_SKINS."$name/$name.php")) $name = "default"; // Check if skin exists
     $this->name         = $name;

     // Skin css and other files
     $this->php          = WM3_cPATH_SKINS."$name/$name.php";
     require($this->php);
     $this->js           = WM3_cPATH_SKINS."$name/$name.js";
     $this->css          = WM3_cSKIN_PATH."$name.css";
     $this->layout_type  = $layout_type;

     // Skin main structure
     $this->_HEAD['head']         = WM3_cSKIN_HEAD_PATH."head.inc";
     $this->_HEAD['head_banners'] = wm3Util::getFileExists(WM3_cSKIN_HEAD_PATH."head_banners.inc",WM3_cSKIN_HEAD_PATH."head.inc");
	 $this->_BODY['full']         = WM3_cSKIN_BODY_PATH."body.inc";
	 $this->_BODY['left']         = wm3Util::getFileExists(WM3_cSKIN_BODY_PATH."body_left.inc", WM3_cSKIN_BODY_PATH."body.inc");
	 $this->_BODY['right']        = wm3Util::getFileExists(WM3_cSKIN_BODY_PATH."body_right.inc",WM3_cSKIN_BODY_PATH."body.inc");
	 $this->_BODY['empty']        = wm3Util::getFileExists(WM3_cSKIN_BODY_PATH."body_empty.inc",WM3_cSKIN_BODY_PATH."body.inc");
     $this->_FOOT['foot']         = WM3_cSKIN_FOOT_PATH."foot.inc";

     // Skin news
	 $this->_NEWS['head']   = WM3_cSKIN_NEWS_PATH."news_head.inc";
     $this->_NEWS['news']   = WM3_cSKIN_NEWS_PATH."news.inc";
	 $this->_NEWS['full']   = WM3_cSKIN_NEWS_PATH."news_full.inc";
     $this->_NEWS['bottom'] = WM3_cSKIN_NEWS_PATH."news_bottom.inc";

     // Skin panels
     $this->_PANEL['left']   = wm3Util::getFileExists(WM3_cSKIN_PANEL_PATH."panel_left.inc",  WM3_cSKIN_PANEL_PATH."panel.inc");
     $this->_PANEL['center'] = wm3Util::getFileExists(WM3_cSKIN_PANEL_PATH."panel_center.inc",WM3_cSKIN_PANEL_PATH."panel.inc");
     $this->_PANEL['right']  = wm3Util::getFileExists(WM3_cSKIN_PANEL_PATH."panel_right.inc", WM3_cSKIN_PANEL_PATH."panel.inc");
     $this->_PANEL['menu']   = wm3Util::getFileExists(WM3_cSKIN_PANEL_PATH."panel_menu.inc",  WM3_cSKIN_PANEL_PATH."panel.inc");

     // Skin page and homepage
     $this->_BODY['page'] = WM3_cSKIN_BODY_PATH."page.inc";
     $this->_BODY['home'] = WM3_cSKIN_BODY_PATH."home.inc";

     // Skin menubar
     $this->_MENU['menubar_start']              = WM3_cSKIN_MENU_PATH."menubar_start.inc";
     $this->_MENU['menubar_item_start']         = WM3_cSKIN_MENU_PATH."menubar_item_start.inc";
     $this->_MENU['menubar_item_end']           = WM3_cSKIN_MENU_PATH."menubar_item_end.inc";
     $this->_MENU['menubar_item_current_start'] = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menubar_item_current_start.inc",WM3_cSKIN_MENU_PATH."menubar_item_start.inc");
     $this->_MENU['menubar_item_current_end']   = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menubar_item_current_end.inc",  WM3_cSKIN_MENU_PATH."menubar_item_end.inc");
     $this->_MENU['menubar_end']                = WM3_cSKIN_MENU_PATH."menubar_end.inc";
     if(file_exists(WM3_cSKIN_MENU_PATH."menubar_separator.inc")) $this->_MENU['menubar_separator'] = WM3_cSKIN_MENU_PATH."menubar_separator.inc"; else $this->_MENU['menubar_separator'] = '';
     $this->_MENU['down_icon']                  = $menu_down_icon;
     $this->_MENU['right_icon']                 = $menu_right_icon;

     // Skin menu
     $this->_MENU['menu_start']              = WM3_cSKIN_MENU_PATH."menu_start.inc";
     $this->_MENU['menu_item_even_start']    = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menu_item_even_start.inc",WM3_cSKIN_MENU_PATH."menu_item_start.inc");
     $this->_MENU['menu_item_even_end']      = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menu_item_even_end.inc",  WM3_cSKIN_MENU_PATH."menu_item_end.inc");
     $this->_MENU['menu_item_odd_start']     = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menu_item_odd_start.inc", WM3_cSKIN_MENU_PATH."menu_item_start.inc");
     $this->_MENU['menu_item_odd_end']       = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menu_item_odd_end.inc",   WM3_cSKIN_MENU_PATH."menu_item_end.inc");     
     
     if(file_exists(WM3_cSKIN_MENU_PATH."menu_item_current_start.inc")) $this->_MENU['menu_item_current_start'] = WM3_cSKIN_MENU_PATH."menu_item_current_start.inc"; else $this->_MENU['menu_item_current_start'] = '';
     if(file_exists(WM3_cSKIN_MENU_PATH."menu_item_current_end.inc"))   $this->_MENU['menu_item_current_end']   = WM3_cSKIN_MENU_PATH."menu_item_current_end.inc";   else $this->_MENU['menu_item_current_end']   = '';
     
     //$this->_MENU['menu_item_current_start'] = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menu_item_current_start.inc",WM3_cSKIN_MENU_PATH."menu_item_start.inc");
     //$this->_MENU['menu_item_current_end']   = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menu_item_current_end.inc",  WM3_cSKIN_MENU_PATH."menu_item_end.inc");
     
     $this->_MENU['menu_end']                = WM3_cSKIN_MENU_PATH."menu_end.inc";
     
     // Skin menudropdown
     $this->_MENU['menudropdown_start']         = WM3_cSKIN_MENU_PATH."menudropdown_start.inc";
     $this->_MENU['menudropdown_item_start']    = WM3_cSKIN_MENU_PATH."menudropdown_item_start.inc";
     $this->_MENU['menudropdown_item_end']      = WM3_cSKIN_MENU_PATH."menudropdown_item_end.inc";
     $this->_MENU['menudropdown_end']           = WM3_cSKIN_MENU_PATH."menudropdown_end.inc";
     $this->_MENU['menubardropdown_start']      = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menubardropdown_start.inc",     WM3_cSKIN_MENU_PATH."menudropdown_start.inc");
     $this->_MENU['menubardropdown_item_start'] = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menubardropdown_item_start.inc",WM3_cSKIN_MENU_PATH."menudropdown_item_start.inc");
     $this->_MENU['menubardropdown_item_end']   = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menubardropdown_item_end.inc",  WM3_cSKIN_MENU_PATH."menudropdown_item_end.inc");
     $this->_MENU['menubardropdown_end']        = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."menubardropdown_end.inc",       WM3_cSKIN_MENU_PATH."menudropdown_end.inc");

	 // Skin channels
     $this->_MISC['channel_block_left_picture']  = WM3_cSKIN_MISC_PATH."channel_block_left_picture.inc";
	 $this->_MISC['channel_block_no_picture']    = WM3_cSKIN_MISC_PATH."channel_block_no_picture.inc";
	 $this->_MISC['channel_block_right_picture'] = WM3_cSKIN_MISC_PATH."channel_block_right_picture.inc";

	 // Skin channel menu
     $this->_MENU['channel_start']   = WM3_cSKIN_MENU_PATH."channel_menu_start.inc";
     $this->_MENU['channel']         = WM3_cSKIN_MENU_PATH."channel_menu.inc";
     $this->_MENU['channel_current'] = wm3Util::getFileExists(WM3_cSKIN_MENU_PATH."channel_menu_current.inc",WM3_cSKIN_MENU_PATH."channel_menu.inc");
	 $this->_MENU['channel_end']     = WM3_cSKIN_MENU_PATH."channel_menu_end.inc";
	 if(file_exists(WM3_cSKIN_MENU_PATH."channel_menu_separator.inc")) $this->_MENU['channel_separator'] = WM3_cSKIN_MENU_PATH."channel_menu_separator.inc"; else $this->_MENU['channel_separator'] = '';

     // Skin for list and form (for all panels, news and pages)
	 for($i = WM3_cSKIN_RENDER_LEFT; $i <= WM3_cSKIN_RENDER_PAGE; $i++)
	  {
       switch($i)
	    {
		 case WM3_cSKIN_RENDER_LEFT:   { $str = "left_";   break; }
		 case WM3_cSKIN_RENDER_CENTER: { $str = "center_"; break; }
		 case WM3_cSKIN_RENDER_RIGHT:  { $str = "right_";  break; }
		 case WM3_cSKIN_RENDER_NEWS:   { $str = "news_";   break; }
		 case WM3_cSKIN_RENDER_PAGE:   { $str = "page_";   break; }
	    }
       $this->_LIST[$i]['header']               = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."header.inc",               WM3_cSKIN_LIST_PATH."header.inc");
	   $this->_LIST[$i]['header_empty']         = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."header_empty.inc",         WM3_cSKIN_LIST_PATH."header_empty.inc");
	   $this->_LIST[$i]['header_title']         = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."header_title.inc",         WM3_cSKIN_LIST_PATH."header_title.inc");
	   $this->_LIST[$i]['header_search']        = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."header_search.inc",        WM3_cSKIN_LIST_PATH."header_search.inc");
	   $this->_LIST[$i]['caption_start']        = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."caption_start.inc",        WM3_cSKIN_LIST_PATH."caption_start.inc");
	   $this->_LIST[$i]['caption']              = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."caption.inc",              WM3_cSKIN_LIST_PATH."caption.inc");
	   $this->_LIST[$i]['caption_end']          = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."caption_end.inc",          WM3_cSKIN_LIST_PATH."caption_end.inc");
       $this->_LIST[$i]['item_start_current']   = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_start_current.inc",   WM3_cSKIN_LIST_PATH."item_start_current.inc");
       $this->_LIST[$i]['item_start_separator'] = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_start_separator.inc", WM3_cSKIN_LIST_PATH."item_start_separator.inc"); 
	   $this->_LIST[$i]['item_start_even']      = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_start_even.inc",      WM3_cSKIN_LIST_PATH."item_start_even.inc");
       $this->_LIST[$i]['item_start_odd']       = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_start_odd.inc",       WM3_cSKIN_LIST_PATH."item_start_odd.inc");
	   $this->_LIST[$i]['item_current']         = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_current.inc",         WM3_cSKIN_LIST_PATH."item_current.inc");
       $this->_LIST[$i]['item_separator']       = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_separator.inc",       WM3_cSKIN_LIST_PATH."item_separator.inc");
	   $this->_LIST[$i]['item_even']            = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_even.inc",            WM3_cSKIN_LIST_PATH."item_even.inc");
       $this->_LIST[$i]['item_odd']             = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_odd.inc",             WM3_cSKIN_LIST_PATH."item_odd.inc");
	   $this->_LIST[$i]['item_end_current']     = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_end_current.inc",     WM3_cSKIN_LIST_PATH."item_end_current.inc");
       $this->_LIST[$i]['item_end_separator']   = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_end_separator.inc",   WM3_cSKIN_LIST_PATH."item_end_separator.inc");
       $this->_LIST[$i]['item_end_even']        = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_end_even.inc",        WM3_cSKIN_LIST_PATH."item_end_even.inc");
       $this->_LIST[$i]['item_end_odd']         = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."item_end_odd.inc",         WM3_cSKIN_LIST_PATH."item_end_odd.inc");
	   $this->_LIST[$i]['bottom']               = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."bottom.inc",               WM3_cSKIN_LIST_PATH."bottom.inc");
	   $this->_LIST[$i]['bottom_end']           = wm3Util::getFileExists(WM3_cSKIN_LIST_PATH.$str."bottom_end.inc",           WM3_cSKIN_LIST_PATH."bottom_end.inc");
	   $this->_FORM[$i]['title']                = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."title.inc",                WM3_cSKIN_FORM_PATH."title.inc");
	   $this->_FORM[$i]['title_empty']          = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."title_empty.inc",          WM3_cSKIN_FORM_PATH."title_empty.inc");
	   $this->_FORM[$i]['title_error']          = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."title_error.inc",          WM3_cSKIN_FORM_PATH."title_error.inc");  
	   $this->_FORM[$i]['item_start_error']     = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."item_start_error.inc",     WM3_cSKIN_FORM_PATH."item_start_error.inc");
	   $this->_FORM[$i]['item_start_even']      = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."item_start_even.inc",      WM3_cSKIN_FORM_PATH."item_start_even.inc");
	   $this->_FORM[$i]['item_start_odd']       = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."item_start_odd.inc",       WM3_cSKIN_FORM_PATH."item_start_odd.inc");
	   $this->_FORM[$i]['item_error']           = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."item_error.inc",           WM3_cSKIN_FORM_PATH."item_error.inc");
	   $this->_FORM[$i]['item_even']            = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."item_even.inc",            WM3_cSKIN_FORM_PATH."item_even.inc");
	   $this->_FORM[$i]['item_odd']             = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."item_odd.inc",             WM3_cSKIN_FORM_PATH."item_odd.inc");
	   $this->_FORM[$i]['item_end_error']       = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."item_end_error.inc",       WM3_cSKIN_FORM_PATH."item_end_error.inc");
	   $this->_FORM[$i]['item_end_even']        = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."item_end_even.inc",        WM3_cSKIN_FORM_PATH."item_end_even.inc");
	   $this->_FORM[$i]['item_end_odd']         = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."item_end_odd.inc",         WM3_cSKIN_FORM_PATH."item_end_odd.inc");
	   $this->_FORM[$i]['separator_start']      = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."separator_start.inc",      WM3_cSKIN_FORM_PATH."separator_start.inc");
	   $this->_FORM[$i]['separator']            = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."separator.inc",            WM3_cSKIN_FORM_PATH."separator.inc");
	   $this->_FORM[$i]['separator_empty']      = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."separator_empty.inc",      WM3_cSKIN_FORM_PATH."separator_empty.inc");
	   $this->_FORM[$i]['separator_end']        = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."separator_end.inc",        WM3_cSKIN_FORM_PATH."separator_end.inc");
	   $this->_FORM[$i]['bottom']               = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."bottom.inc",               WM3_cSKIN_FORM_PATH."bottom.inc");
	   $this->_FORM[$i]['bottom_empty']         = wm3Util::getFileExists(WM3_cSKIN_FORM_PATH.$str."bottom_empty.inc",         WM3_cSKIN_FORM_PATH."bottom_empty.inc");
      }

     // Skin user side
     $this->_BODY['user_page'] = wm3Util::getFileExists(WM3_cSKIN_BODY_PATH."user_page.inc",WM3_cSKIN_BODY_PATH."admin_page.inc");

     // Skin admin side
     $this->_HEAD['admin_head']      = WM3_cSKIN_HEAD_PATH."admin_head.inc";
     $this->_BODY['admin_page']      = WM3_cSKIN_BODY_PATH."admin_page.inc";
     $this->_FOOT['admin_foot']      = WM3_cSKIN_FOOT_PATH."admin_foot.inc";
     $this->_MENU['admin_start']     = WM3_cSKIN_MENU_PATH."admin_menu_start.inc";
     $this->_MENU['admin']           = WM3_cSKIN_MENU_PATH."admin_menu.inc";
     $this->_MENU['admin_current']   = WM3_cSKIN_MENU_PATH."admin_menu_current.inc";
     $this->_MENU['admin_end']       = WM3_cSKIN_MENU_PATH."admin_menu_end.inc";
	 $this->_MENU['admin_separator'] = WM3_cSKIN_MENU_PATH."admin_menu_separator.inc"; // Unused
     $this->_SUBMENU['admin_start']  = WM3_cSKIN_MENU_PATH."admin_submenu_start.inc";
     $this->_SUBMENU['admin']        = WM3_cSKIN_MENU_PATH."admin_submenu.inc";
     $this->_SUBMENU['admin_end']    = WM3_cSKIN_MENU_PATH."admin_submenu_end.inc";
	 //TODO fare anche qui admin_submenu_current e admin_submenu_separator???

     // Skin chat side
     $this->_HEAD['chat_head'] = wm3Util::getFileExists(WM3_cSKIN_HEAD_PATH."chat_head.inc",WM3_cSKIN_HEAD_PATH."admin_head.inc");
     $this->_FOOT['chat_foot'] = WM3_cSKIN_FOOT_PATH."chat_foot.inc";

     // Skin rows width
     $this->left_width   = $left_width;
     $this->center_width = $center_width;
     $this->right_width  = $right_width;
     if($this->layout_type == WM3_cSKIN_LAYOUT_FLUID)
      {
       $this->left_extra_width  = 1;
       $this->right_extra_width = 1;
       $this->left_width  -= $this->left_extra_width;
       $this->right_width -= $this->right_extra_width;
      }
     else $this->left_extra_width = $this->right_extra_width = 0;

     // Logo and banners
     $this->logo           = $_LOGO['logo'];
     $this->logo_width     = $_LOGO['logo_width'];
     $this->logo_height    = $_LOGO['logo_height'];
     $this->logo_printable = $_LOGO['logo_printable'];
     $this->_BANNERS = $_BANNERS;

     // Other items
     $this->_MISC['frame_picture']                  = WM3_cSKIN_MISC_PATH."frame_picture.inc";
	 $this->_MISC['frame_directory']                = WM3_cSKIN_MISC_PATH."frame_directory.inc";
	 $this->_MISC['frame_product']                  = WM3_cSKIN_MISC_PATH."frame_product.inc";
	 $this->_MISC['frame_product_no_picture']       = WM3_cSKIN_MISC_PATH."frame_product_no_picture.inc";
	 $this->_MISC['forum_quote']                    = WM3_cSKIN_MISC_PATH."forum_quote.inc";
	 $this->_MISC['code_start']                     = WM3_cSKIN_MISC_PATH."code_start.inc";
	 $this->_MISC['code_end']                       = WM3_cSKIN_MISC_PATH."code_end.inc";
     $this->_MISC['horizontal_bar']                 = WM3_cSKIN_MISC_PATH."horizontal_bar.inc";
     $this->_MISC['vertical_bar']                   = WM3_cSKIN_MISC_PATH."vertical_bar.inc";
     $this->_MISC['item_start_bar_vertical']        = WM3_cSKIN_MISC_PATH."item_start_bar_vertical.inc";
     $this->_MISC['item_bar_vertical']              = WM3_cSKIN_MISC_PATH."item_bar_vertical.inc";
     $this->_MISC['item_end_bar_vertical']          = WM3_cSKIN_MISC_PATH."item_end_bar_vertical.inc";
     $this->_MISC['item_start_bar_horizontal_even'] = WM3_cSKIN_MISC_PATH."item_start_bar_horizontal_even.inc";
     $this->_MISC['item_bar_horizontal_even']       = WM3_cSKIN_MISC_PATH."item_bar_horizontal_even.inc";
     $this->_MISC['item_end_bar_horizontal_even']   = WM3_cSKIN_MISC_PATH."item_end_bar_horizontal_even.inc";
     $this->_MISC['item_start_bar_horizontal_odd']  = WM3_cSKIN_MISC_PATH."item_start_bar_horizontal_odd.inc";
     $this->_MISC['item_bar_horizontal_odd']        = WM3_cSKIN_MISC_PATH."item_bar_horizontal_odd.inc";
     $this->_MISC['item_end_bar_horizontal_odd']    = WM3_cSKIN_MISC_PATH."item_end_bar_horizontal_odd.inc";

	 $this->_SEPARATOR['separator'] = $separator;
     $this->_SEPARATOR['path']      = $path_separator;
     $this->_QUOTE['open']  = $quote_open;
     $this->_QUOTE['close'] = $quote_close;
	 $this->_FORUM_ICON    = $_FORUM_ICON;
	 //$this->_FORUM_NEW_POST[1] = $_FORUM_NEW_POST[1];
     $this->_STARS[0]       = $_STARS[0];
     if(isset($_STARS[25])) $this->_STARS[25] = $_STARS[25]; else $this->_STARS[25] = $_STARS[50];
     $this->_STARS[50]      = $_STARS[50];
     if(isset($_STARS[75])) $this->_STARS[75] = $_STARS[75]; else $this->_STARS[75] = $_STARS[50];
     $this->_STARS[100]     = $_STARS[100];
	 $this->left_page_title  = $left_page_title;
	 $this->right_page_title = $right_page_title;
    }

   public function renderFootInformations($w3)
    {
     // Render site foot informations and visitors counter
	 if(wm3Section::isActionPrintable($w3)) // Printable news foot informations
	  return $w3->getPreferences('site_address');

	 switch($w3->getPreferences('foot_content'))
	  {
	   case WM3_cPREFERENCES_FOOT_ALL:
	    return "Total visitors ".wm3Preferences::loadTotalVisitors($w3)." (".wm3Statistic::getTodayVisits($w3)." today ".wm3Util::renderDate($w3,time(),$w3->getHomeLanguage(),true,'',false,true).")"."<br>Page generated in ".wm3Util::delayTime()." seconds, ".$w3->getDBObj()->getQueriesAffected()." queries";
	   case WM3_cPREFERENCES_FOOT_COUNTER_DATE:
	    return "Total visitors ".wm3Preferences::loadTotalVisitors($w3)." (".wm3Statistic::getTodayVisits($w3)." today ".wm3Util::renderDate($w3,time(),$w3->getHomeLanguage(),true,'',false,true).")";
	   case WM3_cPREFERENCES_FOOT_COUNTER_TIME:
        return "Total visitors ".wm3Preferences::loadTotalVisitors($w3)." (".wm3Statistic::getTodayVisits($w3)." today)"." (Page generated in ".wm3Util::delayTime()." seconds, ".$w3->getDBObj()->getQueriesAffected()." queries)";
       case WM3_cPREFERENCES_FOOT_DATE_TIME:
        return wm3Util::renderDate($w3,time(),$w3->getHomeLanguage(),true,'',false,true)." (Page generated in ".wm3Util::delayTime()." seconds, ".$w3->getDBObj()->getQueriesAffected()." queries)";
       case WM3_cPREFERENCES_FOOT_COUNTER:
        return "Total visitors ".wm3Preferences::loadTotalVisitors($w3)." (".wm3Statistic::getTodayVisits($w3)." today)";
       case WM3_cPREFERENCES_FOOT_DATE:
        return wm3Util::renderDate($w3,time(),$w3->getHomeLanguage(),true,'',false,true);
       case WM3_cPREFERENCES_FOOT_TIME:
        return "Page generated in ".wm3Util::delayTime()." seconds, ".$w3->getDBObj()->getQueriesAffected()." queries";
	   case WM3_cPREFERENCES_FOOT_NONE:
        return "";
	  }
    }

   public function renderFootAdminInformations($w3)
    {
     // Render site foot admin informations
     if($w3->getAuthenticateAdminID()) return "Page generated in ".wm3Util::delayTime()." seconds, ".$w3->getDBObj()->getQueriesAffected()." queries";
    }

   public function makeBanner($w3,$positionID)
    {
     return wm3Banner::renderBanner($w3,$this->_BANNERS[$positionID-1],$positionID,$w3->getPanelObj()->isColumnEmpty(WM3_cPANEL_LEFT),$w3->getPanelObj()->isColumnEmpty(WM3_cPANEL_RIGHT));
    }

   public function makeMetatags($w3)
    {
	 return wm3Metatag::renderMetatags($w3);
	}

   public function makeLogo($w3)
    {
     // Create the logo (a normal image, a flash logo or printable logo)
	 if(wm3Section::isActionPrintable($w3)) return "<img src=\"".WM3_cPATH_LOGO.$this->logo_printable."\" border=\"0\">";
     if(wm3Util::checkExtension($this->logo,array('swf')))
      {
       return "<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=5,0,0,0\" width=\"".$this->logo_width."\" height=\"".$this->logo_height."\">
                <param name=\"movie\"   value=\"".WM3_cPATH_LOGO.$this->logo."\">
                <param name=\"menu\"    value=\"false\">
                <param name=\"quality\" value=\"high\">
                <embed src=\"".WM3_cPATH_LOGO.$this->logo."\" quality=\"high\" menu=\"false\" pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\" type=\"application/x-shockwave-flash\" width=\"".$this->logo_width."\" height=\"".$this->logo_height."\">
               </embed></object>";
      }
     else return "<a href=\"".WM3_cCONFIG_HOME_FILE."\"><img src=\"".WM3_cPATH_LOGO.$this->logo."\" border=\"0\"></a>";
    }

   public function makeMenuBar($w3)
    {
     // Create main menu as an horizontal menu bar (home side)
     $_MENUS = $w3->getMenusArray();

     $any_item = false;
     for($i=0;$i<count($_MENUS);$i++) // Check if main menu have at least an item
      {
	   $row = $_MENUS[$i];
       if($row->menuID == WM3_cMAIN_MENU) { $any_item = true; break; }
      }
     if(!$any_item) return; // No items in main menu

     $first = true;
     require($this->_MENU['menubar_start']);

     for($i=0;$i<count($_MENUS);$i++)
      {
	   $row = $_MENUS[$i];
       if($row->menuID == WM3_cMAIN_MENU) // Only main menu bar items
        {
         if($row->menudropdownID) $icon = $this->getMenuDownIcon(); else $icon = '';
         $menu_item = wm3Menu::makeMenuItemLink($row,$icon);
	     if(!$first && file_exists($this->_MENU['menubar_separator'])) require($this->_MENU['menubar_separator']); if($first) $first = false;
         // TODO Check menu_current
         if($row->linkID == $w3->getVariable('pageID','get') ) require($this->_MENU['menubar_item_current_start']);
         else require($this->_MENU['menubar_item_start']);
         if($row->menudropdownID) wm3Skin::renderDropdownMenu($w3,$row->menudropdownID,true); // Menu item have a submenu
         if($row->linkID == $w3->getVariable('pageID','get') ) require($this->_MENU['menubar_item_current_end']);
         else require($this->_MENU['menubar_item_end']);
        }
      }
     require($this->_MENU['menubar_end']);
    }

   public function makeMenuPanel($w3,$menuID)
    {
     // Create panel menu (home side)
     $_MENUS = $w3->getMenusArray();
     if(count($_MENUS) == 0) return '';

	 ob_start();
     //$first = true;
     $k = 0;
     require($this->_MENU['menu_start']);

     for($i=0;$i<count($_MENUS);$i++)
      {
	   $row = $_MENUS[$i];
       if($row->menuID == $menuID)
        {
         if($row->menudropdownID) $icon = $this->getMenuRightIcon(); else $icon = '';
         $menu_item = wm3Menu::makeMenuItemLink($row,$icon);
	     //if(!$first && file_exists($this->_MENU['menubar_separator'])) require($this->_MENU['menubar_separator']); if($first) $first = false;
         if($row->linkID == $w3->getVariable('pageID','get') && $this->_MENU['menu_item_current_start']) require($this->_MENU['menu_item_current_start']);
         else {
			   if($k%2 == 0) require($this->_MENU['menu_item_even_start']); 
			   else          require($this->_MENU['menu_item_odd_start']); 
              }
         if($row->menudropdownID) wm3Skin::renderDropdownMenu($w3,$row->menudropdownID,false); // Menu item have a submenu
         if($row->linkID == $w3->getVariable('pageID','get') && $this->_MENU['menu_item_current_end']) require($this->_MENU['menu_item_current_end']);
         else {
			   if($k%2 == 0) require($this->_MENU['menu_item_even_end']); 
			   else          require($this->_MENU['menu_item_odd_end']); 
              }
         $k++;
        }
      }
     require($this->_MENU['menu_end']);
  	 $str = ob_get_contents();
	 ob_end_clean();
	 return $str;
    }

   public function renderDropdownMenu($w3,$menuID,$main = false,$deep = 0)
    {
	 $_MENUS = $w3->getMenusArray();
	 if($deep > 9) return; // Avoid menu loops (max 10 submenu level)
     if($main) require($this->_MENU['menubardropdown_start']);
     else      require($this->_MENU['menudropdown_start']);
     for($i=0;$i<count($_MENUS);$i++)
      {
	   $row = $_MENUS[$i];
	   if($row->menuID == $menuID)
	    {
         if($row->menudropdownID) $icon = $this->getMenuRightIcon(); else $icon = '';
         $menu_item = wm3Menu::makeMenuItemLink($row,$icon);
         if($main) require($this->_MENU['menubardropdown_item_start']);
         else      require($this->_MENU['menudropdown_item_start']);
         if($row->menudropdownID) wm3Skin::renderDropdownMenu($w3,$row->menudropdownID,false,++$deep); // Recursive submenu
         if($main) require($this->_MENU['menubardropdown_item_end']);
         else      require($this->_MENU['menudropdown_item_end']);
	    }
	  }
     if($main) require($this->_MENU['menubardropdown_end']);
     else      require($this->_MENU['menudropdown_end']);
    }

   public function makeChannelsMenu($w3)
    {
     // Create horizontal channels menu bar (home side)
     if(!$w3->getPreferences('show_home_channels') && !$w3->getSection()) return;
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_channels_categories
                                   WHERE enabled = '".WM3_cENABLED."' AND languageID = '".$w3->getHomeLanguage()."'
                                   ORDER BY name");
     if(!$w3->getDBObj()->totalRows($rs)) return '';

     require($this->_MENU['channel_start']);//channel menu start del titolo del canale TODO
     while($row = $w3->getDBObj()->fetch($rs))
      {
       // Channel title
       $menu_item = $row->name;
       require($this->_MENU['channel']);//channel menu del titolo del canale TODO

       // Subchannels
       $rs_sub = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
                                         WHERE enabled = '".WM3_cENABLED."' AND categoryID = '$row->categoryID' AND languageID = '".$w3->getHomeLanguage()."'
                                         ORDER BY ts");
	   $first = true;
	   //require($this->_MENU['channel_start']); TODO decommentare quando si aggiungerà channel menu start,channel menu,channel menu end del titolo del canale 
       while($row_sub = $w3->getDBObj()->fetch($rs_sub))
        {
         $menu_item = "<a href=\"".WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_CHANNELS."&subchannelID=$row_sub->subcategoryID\">$row_sub->name</a>";
		 if(!$first && file_exists($this->_MENU['channel_separator'])) require($this->_MENU['channel_separator']); if($first) $first = false;
         // TODO check channel_menu_current (fare anche per la sezione channel ???)
         //if($row->linkID == $w3->getVariable('pageID','get') ) require($this->_MENU['channel_current']);
         //else require($this->_MENU['channel']);
		 require($this->_MENU['channel']);
        }
	   //require($this->_MENU['channel_end']);TODO decommentare quando si aggiungerà channel menu start,channel menu,channel menu end del titolo del canale 
      }
     require($this->_MENU['channel_end']);//channel menu end del titolo del canale TODO
    }

   public function makeMenu($w3)
    {
     // Create admin side or user side main menu
     if($w3->getStage() == WM3_cSTAGE_USER)  return $w3->getSkinObj()->makeUserMenu($w3);
     if($w3->getStage() == WM3_cSTAGE_ADMIN) return $w3->getSkinObj()->makeAdminMenu($w3);
    }

   public function makeUserMenu($w3)
    {
     // Create user main menu
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                                   WHERE userID = '".$w3->getAuthenticateUserID()."'");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";

     $_DATA = wm3User::getSectionUserDataArray($w3);

     // Menu start
     require($this->_MENU['admin_start']);
     $menu_item = wm3Util::actionButton(WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&section=0",$_DATA['img'][0],$_DATA['alt'][0],"","",0,32,32,"default");
     if($w3->getSection() == WM3_cSECTION_HOME) require($this->_MENU['admin_current']); else require($this->_MENU['admin']);
     // Menu items
     for($i = 1; $i < count($_DATA['section']); $i++) // 0 its (always active) user home (max 8 items)
      {
       if(wm3User::checkUserPermission($w3,$i) && $_DATA['render'][$i])
        {
         $menu_item = wm3Util::actionButton(WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&section=".$_DATA['section'][$i],$_DATA['img'][$i],$_DATA['alt'][$i],"","",0,32,32,"default");
         // TODO fare admin_menu_separator ???
         if($_DATA['section'][$i] == $w3->getSection()) require($this->_MENU['admin_current']); else require($this->_MENU['admin']);
        }
      }
     // Expansions menu items
     $_EXPANSION_DATA = wm3Expansion::getExpansionDataArray($w3,WM3_cEXPANSION_TYPE_USER,false);
     if(isset($_EXPANSION_DATA['section']))
      {
       for($i = 0; $i < count($_EXPANSION_DATA['section']); $i++)
        {
         $menu_item = wm3Util::actionButton(WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&section=".$_EXPANSION_DATA['section'][$i],$_EXPANSION_DATA['img'][$i],$_EXPANSION_DATA['alt'][$i],"","",0,32,32,"default","_self",WM3_cPATH_EXPANSION.$_EXPANSION_DATA['folder'][$i]."/");
         // TODO fare admin_menu_separator ???
         if($_EXPANSION_DATA['section'][$i] == $w3->getSection()) require($this->_MENU['admin_current']); else require($this->_MENU['admin']);
        }
       }
     // Menu end
     require($this->_MENU['admin_end']);
    }

   public function makeAdminMenu($w3)
    {
     // Create admin main menu
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                                   WHERE userID = '".$w3->getAuthenticateAdminID()."'");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";

     $_DATA = wm3User::getSectionAdminDataArray($w3);
     // Menu start
     require($this->_MENU['admin_start']);
     $menu_item = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=0",$_DATA['img'][0],$_DATA['alt'][0],"","",0,32,32,"default");
     if($w3->getSection() == WM3_cSECTION_HOME) require($this->_MENU['admin_current']); else require($this->_MENU['admin']);
     // Menu items
     for($i = 1; $i < count($_DATA['section']); $i++) // 0 its (always active) admin home (max 40 items)
      {
       if(wm3User::checkAdminPermission($w3,$_DATA['section'][$i]) && $_DATA['render'][$i])
        {
         $menu_item = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".$_DATA['section'][$i],$_DATA['img'][$i],$_DATA['alt'][$i],"","",0,32,32,"default");
		 // TODO fare admin_menu_separator ???
         if($_DATA['section'][$i] == $w3->getSection()) require($this->_MENU['admin_current']); else require($this->_MENU['admin']);
        }
      }
     // Expansions menu items
     $_EXPANSION_DATA = wm3Expansion::getExpansionDataArray($w3,WM3_cEXPANSION_TYPE_ADMIN,true);
     if(isset($_EXPANSION_DATA['section']))
      {
       for($i = 0; $i < count($_EXPANSION_DATA['section']); $i++)
        {
         $menu_item = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".$_EXPANSION_DATA['section'][$i],$_EXPANSION_DATA['img'][$i],$_EXPANSION_DATA['alt'][$i],"","",0,32,32,"default","_self",WM3_cPATH_EXPANSION.$_EXPANSION_DATA['folder'][$i]."/");
         // TODO fare admin_menu_separator ???
         if($_EXPANSION_DATA['section'][$i] == $w3->getSection()) require($this->_MENU['admin_current']); else require($this->_MENU['admin']);
        }
      }
     // Menu end
     require($this->_MENU['admin_end']);
    }

   public function makeSubMenu($w3,$submenu)
    {
     if($submenu)
      {
       if(file_exists(WM3_cPATH_INCLUDE.$submenu)) require(WM3_cPATH_INCLUDE.$submenu);
       else                                        require(WM3_cPATH_EXPANSION.$submenu);
      }
     else echo '&nbsp;';
	}

   public function makeWidth($align,$w3)
    {
     // Get the due body rows width to set it in the $w3->_skin
     if($w3->getStage() != WM3_cSTAGE_HOME) { $this->adjustWidth(WM3_cPANEL_LEFT); $this->adjustWidth(WM3_cPANEL_RIGHT); }
     if($w3->getPanelObj()->isColumnEmpty($align)) $this->adjustWidth($align);
    }

   public function adjustWidth($align)
    {
     // Adjust rows body width to set it in the $w3->_skin
     if($align == WM3_cPANEL_LEFT)
      {
       $this->center_width += ($this->left_width + $this->left_extra_width);
       $this->left_width       = 0;
       $this->left_extra_width = 0;
      }
     if($align == WM3_cPANEL_RIGHT)
      {
       $this->center_width += ($this->right_width + $this->right_extra_width);
       $this->right_width       = 0;
       $this->right_extra_width = 0;
      }    	
    }

   public function getLeftContent($w3)
    {
     // Get left site content
     if($w3->getStage() == WM3_cSTAGE_HOME)
      $w3->getPanelObj()->renderPanels($w3,WM3_cPANEL_LEFT);
    }

   public function getCenterContent($w3)
    {
     // Get center site content
     if($w3->getStage() == WM3_cSTAGE_HOME) $w3->getPageObj()->renderHomePage($w3);
     if($w3->getStage() == WM3_cSTAGE_USER)
      {
	   if($w3->getAuthenticateUserID()) $w3->getPageObj()->renderUserPage($w3);
	   else                             $w3->getPageObj()->renderHomePage($w3); // User login form
      }
     if($w3->getStage() == WM3_cSTAGE_ADMIN)
      {
	   if($w3->getAuthenticateAdminID()) $w3->getPageObj()->renderAdminPage($w3);
	   else                              $w3->getPageObj()->renderHomePage($w3); // Admin login form
	  }
	 if($w3->getStage() == WM3_cSTAGE_CHAT) $w3->getPageObj()->renderHomePage($w3);
	 if($w3->getStage() == WM3_cSTAGE_RSS)  $w3->getPageObj()->renderHomePage($w3);
    }

   public function getRightContent($w3)
    {
     // Get right site content
     if($w3->getStage() == WM3_cSTAGE_HOME)
      $w3->getPanelObj()->renderPanels($w3,WM3_cPANEL_RIGHT);
    }

   public static function getFormStyleArray($_FIELD)
    {
     // Get the due skin for each field in a form
     for($i = 0; $i < sizeof($_FIELD); $i++)
	  $_STYLE[$_FIELD[$i]] = $i%2;
     return $_STYLE;   
    }

   public function getLeftWidth()   { return $this->left_width;   }
   
   public function getCenterWidth() { return $this->center_width; }
   
   public function getRightWidth()  { return $this->right_width;  }
   
   public function getLeftExtraWidth() { return $this->left_extra_width; }
   
   public function getRightExtraWidth() { return $this->right_extra_width; }

   public function getJS() { return $this->js; }

   public function getCSS($w3)  {
	                             if(wm3Section::isActionPrintable($w3)) return WM3_cPATH_INCLUDE."printable.css";
							     else                                   return $this->css;
						   	    }

   public function getHead($w3) {
	                             if(wm3Section::isActionPrintable($w3)) return WM3_cPATH_INCLUDE."printable_head.inc";
                                 else {
								       if($w3->getPreferences('banners_enabled')) return $this->_HEAD['head_banners'];
									   else                                       return $this->_HEAD['head'];
								      }
							    }

   public function getBody($w3) {
	                             if(wm3Section::isActionPrintable($w3)) return WM3_cPATH_INCLUDE."printable_body.inc";
								 else {
                                       if($w3->getPanelObj()->isColumnEmpty(WM3_cPANEL_LEFT) &&
                                          $w3->getPanelObj()->isColumnEmpty(WM3_cPANEL_RIGHT)) return $this->_BODY['empty'];
                                       if($w3->getPanelObj()->isColumnEmpty(WM3_cPANEL_LEFT))  return $this->_BODY['right'];
									   if($w3->getPanelObj()->isColumnEmpty(WM3_cPANEL_RIGHT)) return $this->_BODY['left'];
                                       return $this->_BODY['full'];
							          }
                                }

   public function getFoot($w3) {
	                             if(wm3Section::isActionPrintable($w3)) return WM3_cPATH_INCLUDE."printable_foot.inc";
	                             else                                   return $this->_FOOT['foot'];
								}

   public function getPage($w3) {
	                             if(wm3Section::isActionPrintable($w3)) return WM3_cPATH_INCLUDE."printable_page.inc";
	                             else                                   return $this->_BODY['page'];
						        }
   
   public function getNewsHead() { return $this->_NEWS['head']; }
   
   public function getNews($full = false) {
	                                       if($full) return $this->_NEWS['full'];
										   else      return $this->_NEWS['news'];
	                                      }

   public function getNewsBottom() { return $this->_NEWS['bottom']; }

   public function getFramePicture() { return $this->_MISC['frame_picture']; }

   public function getFrameDirectory() { return $this->_MISC['frame_directory']; }

   public function getFrameProduct($image) {
	                                        if($image) return $this->_MISC['frame_product'];
											else       return $this->_MISC['frame_product_no_picture'];
										   }

   public function getChannelBlockLeftPicture() { return $this->_MISC['channel_block_left_picture']; }
   
   public function getChannelBlockNoPicture() { return $this->_MISC['channel_block_no_picture']; }
   
   public function getChannelBlockRightPicture() { return $this->_MISC['channel_block_right_picture']; }

   public function getChannelMenuStart() { return eval(file_get_contents($this->_MENU['channel_start'])); }
   
   public function getChannelMenu() { return $this->_MENU['channel']; }
   
   public function getChannelMenuEnd() { return $this->_MENU['channel_end']; }

   public function getListHeader($empty) {
                                          if($empty) return $this->_LIST[$this->current_skin_render]['header'];
                                          else       return $this->_LIST[$this->current_skin_render]['header_empty'];
                                         }

   public function getListHeaderTitle()   { return $this->_LIST[$this->current_skin_render]['header_title']; }
   
   public function getListHeaderSearch()  { return $this->_LIST[$this->current_skin_render]['header_search']; }

   public function getListCaptionStart()  { return $this->_LIST[$this->current_skin_render]['caption_start']; }

   public function getListCaption()       { return $this->_LIST[$this->current_skin_render]['caption']; }

   public function getListCaptionEnd()    { return $this->_LIST[$this->current_skin_render]['caption_end']; }

   public function getListItemStart($p,$current,$separator,$bar_vertical,$bar_horizontal)
    {
     if($bar_horizontal)
	  {
       if($p%2 == 0) return $this->_MISC['item_start_bar_horizontal_even'];
	   else          return $this->_MISC['item_start_bar_horizontal_odd'];
      }
     if($bar_vertical) return $this->_MISC['item_start_bar_vertical'];
	 if($current)      return $this->_LIST[$this->current_skin_render]['item_start_current'];
	 if($separator)    return $this->_LIST[$this->current_skin_render]['item_start_separator'];
	 if($p%2 == 0) return $this->_LIST[$this->current_skin_render]['item_start_even'];
	 else          return $this->_LIST[$this->current_skin_render]['item_start_odd'];
    }

   public function getListItem($p,$current,$separator,$bar_vertical,$bar_horizontal)
    {
     if($bar_horizontal)
	  {
       if($p%2 == 0) return $this->_MISC['item_bar_horizontal_even'];
	   else          return $this->_MISC['item_bar_horizontal_odd'];
      }
     if($bar_vertical) return $this->_MISC['item_bar_vertical'];
	 if($current)      return $this->_LIST[$this->current_skin_render]['item_current'];
	 if($separator)    return $this->_LIST[$this->current_skin_render]['item_separator'];
	 if($p%2 == 0) return $this->_LIST[$this->current_skin_render]['item_even'];
	 else          return $this->_LIST[$this->current_skin_render]['item_odd'];
    }

   public function getListItemEnd($p,$current,$bar_vertical,$bar_horizontal)
    {
     if($bar_horizontal)
	  {
       if($p%2 == 0) return $this->_MISC['item_end_bar_horizontal_even'];
	   else          return $this->_MISC['item_end_bar_horizontal_odd'];
      }
	 if($bar_vertical) return $this->_MISC['item_end_bar_vertical'];
	 if($current)      return $this->_LIST[$this->current_skin_render]['item_end_current'];
	 if($p%2 == 0) return $this->_LIST[$this->current_skin_render]['item_end_even'];
	 else          return $this->_LIST[$this->current_skin_render]['item_end_odd'];
	}

   public function getListBottom()    { return $this->_LIST[$this->current_skin_render]['bottom']; }

   public function getListBottomEnd() { return $this->_LIST[$this->current_skin_render]['bottom_end']; }

   public function getFormTitle($error,$empty)
    {
	 if($error) return $this->_FORM[$this->current_skin_render]['title_error'];
	 else       {
		         if($empty) return $this->_FORM[$this->current_skin_render]['title_empty'];
				 else       return $this->_FORM[$this->current_skin_render]['title'];
			    }
    }

   public function getFormItemStart($p,$error)
    {
	 if($error)    return $this->_FORM[$this->current_skin_render]['item_start_error'];
	 if($p%2 == 0) return $this->_FORM[$this->current_skin_render]['item_start_even'];
	 else          return $this->_FORM[$this->current_skin_render]['item_start_odd'];
    }

   public function getFormItem($p,$error)
    {
	 if($error)    return $this->_FORM[$this->current_skin_render]['item_error'];
	 if($p%2 == 0) return $this->_FORM[$this->current_skin_render]['item_even'];
	 else          return $this->_FORM[$this->current_skin_render]['item_odd'];
    }

   public function getFormItemEnd($p,$error)
    {
	 if($error)    return $this->_FORM[$this->current_skin_render]['item_end_error'];
	 if($p%2 == 0) return $this->_FORM[$this->current_skin_render]['item_end_even'];
	 else          return $this->_FORM[$this->current_skin_render]['item_end_odd'];
    }

   public function getFormSeparatorStart()
    {
	 return $this->_FORM[$this->current_skin_render]['separator_start'];
	}

   public function getFormSeparator($title)
    {
	 if($title) return $this->_FORM[$this->current_skin_render]['separator'];
	 else       return $this->_FORM[$this->current_skin_render]['separator_empty'];
	}

   public function getFormSeparatorEnd()
    {
	 return $this->_FORM[$this->current_skin_render]['separator_end'];
	}

   public function getFormBottom($empty) {
	                                      if($empty) return $this->_FORM[$this->current_skin_render]['bottom_empty'];
                                          else       return $this->_FORM[$this->current_skin_render]['bottom'];
                                         }

   public function getPanelLeft()   { return $this->_PANEL['left']; }

   public function getPanelCenter() { return $this->_PANEL['center']; }

   public function getPanelRight()  { return $this->_PANEL['right']; }
   
   public function getPanelMenu()   { return $this->_PANEL['menu']; }

   public function getLeftPageTitle()  { return $this->left_page_title;  }

   public function getRightPageTitle() { return $this->right_page_title; }

   public function getHome() { return $this->_BODY['home']; }

   public function getUserPage($w3)  {
	                                  // Function ready for printable action in user stage
	                                  if(wm3Section::isActionPrintable($w3)) return WM3_cPATH_INCLUDE."printable_page.inc";
	                                  else                                   return $this->_BODY['user_page'];
								     }

   public function getAdminHead($w3) {
	                                  if(wm3Section::isActionPrintable($w3)) return WM3_cPATH_INCLUDE."printable_head.inc";
                                      else                                   return $this->_HEAD['admin_head'];
							         }
   
   public function getAdminPage($w3) {
	                                  if(wm3Section::isActionPrintable($w3)) return WM3_cPATH_INCLUDE."printable_page.inc";
	                                  else                                   return $this->_BODY['admin_page'];
									 }
   
   public function getAdminFoot($w3) {
	                                  if(wm3Section::isActionPrintable($w3)) return WM3_cPATH_INCLUDE."printable_foot.inc";
                                      else                                   return $this->_FOOT['admin_foot'];
							         }
   
   public function getAdminMenuStart() { return $this->_MENU['admin_start']; }
   
   public function getAdminMenu() { return $this->_MENU['admin']; }
   
   public function getAdminMenuCurrent() { return $this->_MENU['admin_current']; }
   
   public function getAdminMenuEnd() { return $this->_MENU['admin_end']; }

   public function getAdminSubMenuStart() { return $this->_SUBMENU['admin_start']; }
   
   public function getAdminSubMenu() { return $this->_SUBMENU['admin']; }

   public function getAdminSubMenuEnd() { return $this->_SUBMENU['admin_end']; }

   public function getChatHead() { return $this->_HEAD['chat_head']; }
   
   public function getChatFoot() { return $this->_FOOT['chat_foot']; }

   public function getSeparator() { return $this->_SEPARATOR['separator']; }

   public function getPathSeparator() { return $this->_SEPARATOR['path']; }
   
   public function getMenuDownIcon()  { return $this->_MENU['down_icon']; }
   
   public function getMenuRightIcon() { return $this->_MENU['right_icon']; }
   
   public function getForumQuote() { return $this->_MISC['forum_quote']; }

   public function getQuoteOpen() { return $this->_QUOTE['open']; }
      
   public function getQuoteClose() { return $this->_QUOTE['close']; }
   
   public function getCodeStart() { return $this->_MISC['code_start']; }

   public function getCodeEnd() { return $this->_MISC['code_end']; }

   public function getHorizontalBar() { return $this->_MISC['horizontal_bar']; }

   public function getVerticalBar() { return $this->_MISC['vertical_bar']; }

   public function getForumIcon($hot,$lock,$new) { return $this->_FORUM_ICON[$hot * 4 + $lock * 2 + $new]; }

   public function getStar($n) { return $this->_STARS[$n]; }
   
   public function getName() { return $this->name; }

   public function getCurrentSkinRender() { return $this->current_skin_render; }

   public function setCurrentSkinRender($current) { $this->current_skin_render = $current; }
  }

?>
